`#include <stdio.h>
`#include <stdlib.h>

`#include "sc_groups_c.h"

/* http_idata */

`#ifndef   _NO_PROTO
void delete_http_idata( http_idata* hd)
`#else  /* _NO_PROTO */
void delete_http_idata( hd)
	http_idata* hd ;
`#endif /* _NO_PROTO */
{
	(void) free ((void *) hd);
}

`#ifndef   _NO_PROTO
static char *           http_idata_getMimeType(http_idata *);
static InputStream *    http_idata_getInputStream(http_idata *);
static int              http_idata_getContentLength(http_idata *);
static int              http_idata_load(http_idata *, sc_stdcs_t *);
static void             http_idata_close(http_idata *);
`#else  /* _NO_PROTO */
static char *           http_idata_getMimeType();
static InputStream *    http_idata_getInputStream();
static int              http_idata_getContentLength();
static int              http_idata_load();
static void             http_idata_close();
`#endif /* _NO_PROTO */

`#ifndef   _NO_PROTO
http_idata * new_http_idata( URL * url)
`#else  /* _NO_PROTO */
http_idata * new_http_idata( url)
	URL * url ;
`#endif /* _NO_PROTO */
{
	http_idata * hd = (http_idata*) malloc ((unsigned) sizeof(http_idata));

	hd->url        = url;
	hd->connection = (*url->getConnection)( url);
	hd->istream    = (*hd->connection->getInputStream)( hd->connection);
			/* this does the handshake */

	hd->close            = http_idata_close;
	hd->getMimeType      = http_idata_getMimeType;
	hd->getInputStream   = http_idata_getInputStream;
	hd->getContentLength = http_idata_getContentLength;
	hd->load             = http_idata_load;

	hd->delete           = delete_http_idata;
	return hd;
}

`#ifndef   _NO_PROTO
void delete_http_transport( http_transport * ht)
`#else  /* _NO_PROTO */
void delete_http_transport( ht)
	http_transport * ht ;
`#endif /* _NO_PROTO */
{
	(void) free ((void*) ht);
}

`#ifndef   _NO_PROTO
static void         sc_transport_chatAsync(sc_transport_t *, sc_stdcs_t *);
static sc_idata_t*  sc_transport_chat(sc_transport_t *, sc_stdcs_t *);
static int          http_transport_connect(void);
static void         http_transport_setProperties(http_transport *, sc_properties *);
static sc_idata_t * http_transport_chatToServer(http_transport *, sc_stdcs_t *);
`#else  /* _NO_PROTO */
static void         sc_transport_chatAsync();
static sc_idata_t*  sc_transport_chat();
static int          http_transport_connect();
static void         http_transport_setProperties();
static sc_idata_t * http_transport_chatToServer();
`#endif /* _NO_PROTO */

`#ifndef   _NO_PROTO
http_transport * new_http_transport( void)
`#else  /* _NO_PROTO */
http_transport * new_http_transport()
`#endif /* _NO_PROTO */
{
	http_transport * h = (http_transport*) malloc ((unsigned) sizeof(http_transport));

	h->chatAsync     = sc_transport_chatAsync;
	h->chat          = sc_transport_chat;
	h->connected     = 0;
	h->connect       = http_transport_connect;
	h->setProperties = http_transport_setProperties;
	h->chatToServer  = http_transport_chatToServer;
	h->delete        = delete_http_transport;

	return h;
}

`#ifndef   _NO_PROTO
http_transport * getNew_http_transport( void)
`#else  /* _NO_PROTO */
http_transport * getNew_http_transport()
`#endif /* _NO_PROTO */
{
	return new_http_transport();
}

`#ifndef   _NO_PROTO
void delete_http_properties( http_properties * hp)
`#else  /* _NO_PROTO */
void delete_http_properties( hp)
	http_properties * hp ;
`#endif /* _NO_PROTO */
{
	(void) free ((void*) hp);
}

`#ifndef   _NO_PROTO
static void     http_properties_seturl(http_properties *, char *, int);
static char *   http_properties_geturl(http_properties *);
static void     http_properties_seturlData(http_properties *, char *, int);
static char *   http_properties_geturlData(http_properties *);
static void     http_properties_setproxyHost(http_properties *, char *, int);
static char *   http_properties_getproxyHost(http_properties *);
static void     http_properties_setproxyPort(http_properties *, char *, int);
static char *   http_properties_getproxyPort(http_properties *);
`#else  /* _NO_PROTO */
static void     http_properties_seturl();
static char *   http_properties_geturl();
static void     http_properties_seturlData();
static char *   http_properties_geturlData();
static void     http_properties_setproxyHost();
static char *   http_properties_getproxyHost();
static void     http_properties_setproxyPort();
static char *   http_properties_getproxyPort();
`#endif /* _NO_PROTO */

`#ifndef   _NO_PROTO
http_properties * new_http_properties( AnyGroup_t * g)
`#else  /* _NO_PROTO */
http_properties * new_http_properties( g)
	AnyGroup_t * g ;
`#endif /* _NO_PROTO */
{
	http_properties * hp = (http_properties*) malloc ((unsigned) sizeof(http_properties));

	hp->group        = g;
	hp->seturl       = http_properties_seturl;
	hp->seturlData   = http_properties_seturlData;
	hp->setproxyHost = http_properties_setproxyHost;
	hp->setproxyPort = http_properties_setproxyPort;

	hp->geturl       = http_properties_geturl;
	hp->geturlData   = http_properties_geturlData;
	hp->getproxyHost = http_properties_getproxyHost;
	hp->getproxyPort = http_properties_getproxyPort;

	hp->url       = (void*)0;
	hp->urldata   = (void*)0;
	hp->proxyhost = (void*)0;
	hp->proxyport = (void*)0;

	hp->delete    = delete_http_properties;

	return hp;
}

/* sc_properties */

`#ifndef   _NO_PROTO
static char * sc_properties_derefValue( sc_properties * scp, void * v, int type)
`#else  /* _NO_PROTO */
static char * sc_properties_derefValue( scp, v, type)
	sc_properties * scp ;
	void          * v ;
	int             type ;
`#endif /* _NO_PROTO */
{
	if (!v)
		return (char*)0;
	switch (type) {
		case PROP_CONSTANT:
			return (char*) v;
		case PROP_VARIABLE:
		{
			char ** s = (char**)v;
			if (!s)
				return (char*)0;
			return *s;
		}
		case PROP_FUNCTION:
		{
			string_f sf = (string_f) v;
			return (*sf)( scp->group);
		}
		default:
			printf("unknown type\n");
			break;
	}
	return (char*)0;
}

/* http_properties */

`#ifndef   _NO_PROTO
static void http_properties_seturl( http_properties * hp, char* val, int type)
`#else  /* _NO_PROTO */
static void http_properties_seturl( hp, val, type)
	http_properties * hp ;
	char            * val ;
	int               type ;
`#endif /* _NO_PROTO */
{
	hp->url     = (void*)val;
	hp->urltype = type;
}

`#ifndef   _NO_PROTO
static char * http_properties_geturl( http_properties * hp)
`#else  /* _NO_PROTO */
static char * http_properties_geturl( hp)
	http_properties * hp ;
`#endif /* _NO_PROTO */
{
	return sc_properties_derefValue( (sc_properties*)hp, hp->url, hp->urltype);
}

`#ifndef   _NO_PROTO
static void http_properties_seturlData( http_properties * hp, char* val, int type)
`#else  /* _NO_PROTO */
static void http_properties_seturlData( hp, val, type)
	http_properties * hp ;
	char            * val ;
	int               type ;
`#endif /* _NO_PROTO */
{
	hp->urldata     = (void*)val;
	hp->urldatatype = type;
}

`#ifndef   _NO_PROTO
static char * http_properties_geturlData( http_properties * hp)
`#else  /* _NO_PROTO */
static char * http_properties_geturlData( hp)
	http_properties * hp ;
`#endif /* _NO_PROTO */
{
	return sc_properties_derefValue( (sc_properties*)hp, hp->urldata, hp->urldatatype);
}

`#ifndef   _NO_PROTO
static void http_properties_setproxyHost( http_properties* hp, char* val, int type)
`#else  /* _NO_PROTO */
static void http_properties_setproxyHost( hp, val, type)
	http_properties* hp ;
	char           * val ;
	int              type ;
`#endif /* _NO_PROTO */
{
	hp->proxyhost     = (void*)val;
	hp->proxyhosttype = type;
}

`#ifndef   _NO_PROTO
static char * http_properties_getproxyHost( http_properties * hp)
`#else  /* _NO_PROTO */
static char * http_properties_getproxyHost( hp)
	http_properties * hp ;
`#endif /* _NO_PROTO */
{
	return sc_properties_derefValue( (sc_properties*)hp, hp->proxyhost, hp->proxyhosttype);
}

`#ifndef   _NO_PROTO
static void http_properties_setproxyPort( http_properties * hp, char* val, int type)
`#else  /* _NO_PROTO */
static void http_properties_setproxyPort( hp, val, type)
	http_properties * hp ;
	char            * val ;
	int               type ;
`#endif /* _NO_PROTO */
{
	hp->proxyport     = (void*)val;
	hp->proxyporttype = type;
}

`#ifndef   _NO_PROTO
static char * http_properties_getproxyPort( http_properties * hp)
`#else  /* _NO_PROTO */
static char * http_properties_getproxyPort( hp)
	http_properties * hp ;
`#endif /* _NO_PROTO */
{
	return sc_properties_derefValue( (sc_properties*)hp, hp->proxyport, hp->proxyporttype);
}

/* sc_transport */

`#ifndef   _NO_PROTO
static int sc_transport_isConnected( sc_transport_t * st)
`#else  /* _NO_PROTO */
`#endif /* _NO_PROTO */
{
	return st->connected;
}

`#ifndef   _NO_PROTO
static void sc_transport_setConnected( sc_transport_t * st, int state)
`#else  /* _NO_PROTO */
static void sc_transport_setConnected( st, state)
	sc_transport_t * st ;
	int              state ;
`#endif /* _NO_PROTO */
{
	st->connected = state;
}

`#ifndef   _NO_PROTO
static sc_idata_t* sc_transport_chat( sc_transport_t * st, sc_stdcs_t * csdata)
`#else  /* _NO_PROTO */
static sc_idata_t* sc_transport_chat( st, csdata)
	sc_transport_t * st ;
	sc_stdcs_t     * csdata ;
`#endif /* _NO_PROTO */
{
	(*st->setProperties)( st, csdata->properties);

	if (!sc_transport_isConnected( st) &&
	    !(*st->connect)( st))
		return (sc_idata_t*)0;

	return (*st->chatToServer)( st, csdata);
}

`#ifndef   _NO_PROTO
void rePollServer ( void *data, void *id)
`#else  /* _NO_PROTO */
void rePollServer ( data, id)
	void* data;
	void* id;
`#endif /* _NO_PROTO */
{
	sc_stdcs_t      * scd = (sc_stdcs_t *)data;
	sc_transport_t * t   = scd->clientserver;

	(*t->chatAsync)( t, scd);
}

`#ifndef   _NO_PROTO
int sc_transport_async_handler ( sc_transport_t * st, sc_stdcs_t * csdata, sc_idata_t * idata)
`#else  /* _NO_PROTO */
int sc_transport_async_handler ( st, csdata, idata)
	sc_transport_t * st ;
	sc_stdcs_t     * csdata ;
	sc_idata_t     * idata ;
`#endif /* _NO_PROTO */
{
	extern void setCallTimer();

	(*st->push_handler)( csdata, idata);

	if (csdata->poll_handler)
		(*csdata->poll_handler)( csdata, csdata->poll);

	return 1;
}

`#ifndef   _NO_PROTO
static void sc_transport_chatAsync( sc_transport_t * st, sc_stdcs_t * csdata)
`#else  /* _NO_PROTO */
static void sc_transport_chatAsync( st, csdata)
	sc_transport_t * st ;
	sc_stdcs_t     * csdata ;
`#endif /* _NO_PROTO */
{
	sc_idata_t * idata;

	idata = sc_transport_chat( st, csdata);

	if (!idata)
		return;

	sc_transport_async_handler( st, csdata, idata);
}


/* http_idata */

`#ifndef   _NO_PROTO
static void http_idata_close( http_idata * hd)
`#else  /* _NO_PROTO */
static void http_idata_close( hd)
	http_idata * hd ;
`#endif /* _NO_PROTO */
{
	if (hd->url) {
		(*hd->url->delete)( hd->url);
		hd->url = (URL*)0;
	}
}

`#ifndef   _NO_PROTO
static char * http_idata_getMimeType( http_idata * hd)
`#else  /* _NO_PROTO */
static char * http_idata_getMimeType( hd)
	http_idata * hd ;
`#endif /* _NO_PROTO */
{
	return (*hd->connection->getContentType)( hd->connection);
}

`#ifndef   _NO_PROTO
static InputStream * http_idata_getInputStream( http_idata * hd)
`#else  /* _NO_PROTO */
`#endif /* _NO_PROTO */
{
	return hd->istream;
}

`#ifndef   _NO_PROTO
static int http_idata_getContentLength( http_idata * hd)
`#else  /* _NO_PROTO */
static int http_idata_getContentLength( hd)
	http_idata * hd ;
`#endif /* _NO_PROTO */
{
	return (*hd->connection->getContentLength)(hd->connection);
}

`#define  StartState  0
`#define  DataState   1
`#define  GoalState   2

`#ifndef   _NO_PROTO
static int http_idata_splitLineAt( char c, char * line, char ** keyp, char ** eolp)
`#else  /* _NO_PROTO */
static int http_idata_splitLineAt( c, line, keyp, eolp)
	char    c ;
	char  * line ;
	char ** keyp ;
	char ** eolp ;
`#endif /* _NO_PROTO */
{
	char * p;

	for (p = line; p && *p; p++) {
		if (*p != c)
			continue;
		*p = '\0';
		*keyp = line;
		*eolp = p+1;
		return 1;
	}
	return 0;
}

`#ifndef   _NO_PROTO
static void http_idata_httpDeSerialize( AnyControl_t * sc, char * toeol, DataInputStream * ds)
`#else  /* _NO_PROTO */
static void http_idata_httpDeSerialize( sc, toeol, ds)
	AnyControl_t    * sc ;
	char            * toeol ;
	DataInputStream * ds ;
`#endif /* _NO_PROTO */
{
	int i;

	if (!sc)
		return;

	i = sc->type;
	if (i == ScUnknownType)
		return;
	switch (i) {
		case ScBooleanType:
			{  int tv = (strcmp( toeol, "true") == 0);

			   SC_SETCONTROL(sc, tv);
			}
			break;
		case ScIntType:
			   SC_SETCONTROL(sc, atoi(toeol));
			break;
		case ScStringType:
			{
				char * oldvalue = SC_GETNEW(sc);
				if (oldvalue)
					free(oldvalue);
				if (toeol)
					toeol = strdup( toeol);

				SC_SETCONTROL(sc, toeol);
			}
			break;
		case ScStringArrayType:
			{
				char ** oldvalue = SC_GETNEW(sc);
				char ** pp;
				for ( pp = oldvalue; pp && *pp; pp++)
					free(*pp);
				if (oldvalue)
					free(oldvalue);
			};
			{
				char ** values;
				char ** pp;
				int i = atoi(toeol);
				int j;
				if (i == 0)
					break;
				values = (char**) malloc ((unsigned) (i+1) * sizeof(char*));
				for (j=0, pp=values; j < i; j++, pp++) {
					*pp = (*ds->readLine)(ds);
					if (!*pp)
						break;
					*pp = strdup(*pp);
				}
				*pp = (char*)0;
				SC_SETCONTROL(sc, values);
			}
			break;
		default:
			break;
	}
}

`#ifndef   _NO_PROTO
static int http_idata_load( http_idata * hd, sc_stdcs_t * data)
`#else  /* _NO_PROTO */
`#endif /* _NO_PROTO */
{
	extern DataInputStream * newDataInputStream();

	InputStream     * i  = (*hd->getInputStream)( hd);
	DataInputStream * ds = newDataInputStream( i);
	char * nextline;

	int   pollvalue    = 0;
	char *callbackname = (char*)0;
	int state          = StartState;
	char * key;
	char * toeol;
	AnyGroup_t * g = data->group;


	while (state != GoalState) {
		nextline = (*ds->readLine)(ds);
		if (!nextline)
			break;

		if (!http_idata_splitLineAt('=', nextline, &key, &toeol))
			break;

		switch (state) {
			case StartState:
				if (strcmp(key,"sc-start"))
					break;
				if (!g->isFrom(toeol)) {
					state = GoalState;
					break;
				}
				state = DataState;
				break;
			case DataState:
				if (strcmp(key,"sc-end") == 0) {
					state = GoalState;
					break;
				}
				if (strcmp(key,"sc-poll") == 0) {
					data->poll = atoi( toeol);
					break;
				}
				if (strcmp(key,"sc-callback") == 0) {
					/* callbackname = strdup(toeol); */
					break;
				}
				{
					AnyControl_t * sc = (*g->findAppElement)( g, key);
					if (!sc)
						break;
					http_idata_httpDeSerialize( sc, toeol,  ds);
					break;
				}
			default:
				break;
		}
	}

	/* (*ds->close)( ds); */
	(*ds->delete)( ds);

	return 1;
}

/* http_transport */

`#ifndef   _NO_PROTO
static int http_transport_connect( void)
`#else  /* _NO_PROTO */
static int http_transport_connect()
`#endif /* _NO_PROTO */
{
	return 1; /* no permanent connections */
}

`#ifndef   _NO_PROTO
static void http_transport_setProperties( http_transport * ht, sc_properties * p)
`#else  /* _NO_PROTO */
static void http_transport_setProperties( ht, p)
	http_transport * ht ;
	sc_properties  * p ;
`#endif /* _NO_PROTO */
{
	ht->properties = (http_properties*)p;
}

`#ifndef   _NO_PROTO
static void http_transport_setupProxyConfiguration( http_transport * ht)
`#else  /* _NO_PROTO */
static void http_transport_setupProxyConfiguration( ht)
	http_transport * ht ;
`#endif /* _NO_PROTO */
{
	int port;
	http_properties * props = ht->properties;

	char * proxyHost = (*props->getproxyHost)( props);
	char * proxyPort = (*props->getproxyPort)( props);

	if (!proxyHost || !*proxyHost) {
		HttpURLConnection_setNoProxy();
		return;
	}


	if (!proxyPort)
		port = 80;
	else
		port = atoi(proxyPort);

	HttpURLConnection_setProxy( proxyHost, port);
}

`#ifndef   _NO_PROTO
URL* http_transport_getURL( http_transport *ht)
`#else  /* _NO_PROTO */
	http_transport * ht ;
`#endif /* _NO_PROTO */
{
	extern URL* newURLandData();
	http_properties * props = ht->properties;

	char * url = (*props->geturl)( props);
	char * urlData;

	if (!url) {
		return (URL*)0;
	}

	urlData = (*props->geturlData)( props);


	return newURLandData( url, urlData);
}

`#ifndef   _NO_PROTO
void http_transport_httpSerialize( AnyControl_t* c, PrintWriter * pw)
`#else  /* _NO_PROTO */
void http_transport_httpSerialize( c, pw)
	AnyControl_t* c ;
	PrintWriter * pw ;
`#endif /* _NO_PROTO */
{
	int i = c->type;
	if (i == ScUnknownType)
		return;
	(*pw->print)( pw, SC_GETNAME(c));
		(*pw->print)( pw, "=");
	switch (i) {
		case ScBooleanType:
			(*pw->printBoolean)( pw, SC_GETCONTROL(c));
			(*pw->println) ( pw, (char*)0);
			break;
		case ScIntType:
			(*pw->printInt)( pw, SC_GETCONTROL(c));
			(*pw->println) ( pw, (char*)0);
			break;
		case ScStringType:
			(*pw->print)( pw, SC_GETCONTROL(c));
			(*pw->println) ( pw, (char*)0);
			break;
		case ScStringArrayType:
			{
			char ** data = SC_GETCONTROL(c);
			char ** pp;
			int i;

			for (i = 0, pp = data; pp && *pp; pp++, i++);

			(*pw->printInt)( pw, i);
			(*pw->println) ( pw, (char*)0);

			while (data && *data) {
				(*pw->println) ( pw, *data++);
			}

			}
			break;
		default:
			break;
	}
}

`#ifndef   _NO_PROTO
void http_transport_submitData( URLConnection * uc, sc_stdcs_t * csdata)
`#else  /* _NO_PROTO */
void http_transport_submitData( uc, csdata)
	URLConnection * uc ;
	sc_stdcs_t    * csdata ;
`#endif /* _NO_PROTO */
{
	extern PrintWriter * newPrintWriter();

	PrintWriter * pw = newPrintWriter( (*uc->getOutputStream)(uc));
	AnyGroup_t  * g  = csdata->group;
	char *        mt = g->mimeType;

	(*pw->print)( pw, "Content-type: ");
		(*pw->println)( pw, mt);
	(*pw->println)( pw, (char*)0);
	(*pw->print)( pw, "sc-start=");
		(*pw->println)( pw, mt);
	(*pw->print)( pw, "sc-callback=");
		(*pw->println)( pw, csdata->name);

	if (csdata->poll) {
		(*pw->print)( pw, "sc-poll=");
			(*pw->printlnInt)( pw, csdata->poll);
	}

	(*g->startAppElementEnumeration)( g);

	while ((*g->hasMoreAppElements)(g)) {
		http_transport_httpSerialize( (*g->getNextAppElement)(g), pw);
	}

	(*pw->print)( pw, "sc-end=");
		pw->println( pw, mt);

	/* (*pw->close)( pw); */
	(*pw->delete)( pw);
}

`#ifndef   _NO_PROTO
sc_idata_t * http_transport_chatToServer( http_transport * ht, sc_stdcs_t * csdata)
`#else  /* _NO_PROTO */
sc_idata_t * http_transport_chatToServer( ht, csdata)
	http_transport * ht ;
	sc_stdcs_t     * csdata ;
`#endif /* _NO_PROTO */
{
	URL * u = http_transport_getURL( ht);
	URLConnection * uc;


	if (!u)
		return (sc_idata_t*)0;

	http_transport_setupProxyConfiguration( ht);

	uc = (*u->openConnection)( u);

	if (csdata->send_data) {
		(*uc->setDoOutput)( uc, 1);
		(*uc->setDoInput)( uc, 1);
		(*uc->setAllowUserInteraction)(uc, 0); /* ? */
		if (csdata->send_data_handler) {
			int_f odh = csdata->send_data_handler;
			(void) (*odh)( uc, csdata);
		} else {
			http_transport_submitData( uc, csdata); /* send data; */
		}
	}
	return (sc_idata_t*) new_http_idata( u);
}
