`#ifndef _TR_HTTP_H
`#define _TR_HTTP_H

#include "groups_c/sc_types.h"
`#include "URL.h"



/* abstract */
typedef struct sc_properties_s
{
	void_f delete;
	AnyGroup_t * group;
} sc_properties;

typedef struct http_properties_s
{
	/* inherited from sc_properties */
	void_f delete;
	AnyGroup_t * group;
	/* private: */
		void * url;
		int    urltype;
		void * urldata;
		int    urldatatype;
		void * proxyhost;
		int    proxyhosttype;
		void * proxyport;
		int    proxyporttype;
	/* public: */
		string_f geturl;
		void_f   seturl;
		string_f geturlData;
		void_f   seturlData;
		string_f getproxyHost;
		void_f   setproxyHost;
		string_f getproxyPort;
		void_f   setproxyPort;
} http_properties;

typedef struct sc_idata_s
{
	/* public: */
		void_f          delete;
		string_f        getMimeType;      /* pv */
		InputStream_f   getInputStream;   /* pv */
		int_f           getContentLength; /* pv */
		int_f           load;             /* pv */
		void_f          close;            /* pv */
} sc_idata_t;
typedef sc_idata_t * (*sc_idata_f)();

typedef struct sc_transport_s
{
	/*public */
		void_f     delete;
		void_f     chatAsync;
		sc_idata_f chat;
		void_f     push_handler;
	/*private */
		int connected;

		int_f      connect;
		void_f     setProperties; /* pv */
		sc_idata_f chatToServer;  /* pv */
} sc_transport_t;

typedef struct http_idata_s
{
	/* inherited from sc_idata_t */
	void_f          delete;
	string_f        getMimeType;
	InputStream_f   getInputStream;
	int_f           getContentLength;
	int_f           load;
	void_f          close;
	/* local */
	URL             * url;
	URLConnection   * connection;
	InputStream     * istream;
} http_idata;

typedef struct http_transport_s
{
	/* inherited from sc_transport */
	void_f     delete;
	void_f     chatAsync;
	sc_idata_f chat;
	void_f     push_handler;
	int        connected;
	int_f      connect;
	void_f     setProperties;
	sc_idata_f chatToServer;
	/* local */
	http_properties * properties;
} http_transport;

`#endif
