#noecho
##message -> codegen.cmd
#include "hdrs/std.mh"
DEBUG(start of codegen.cmd)
#ifndef _STRING_MODULE
#       include "String.m"
#       define _STRING_MODULE 1
#endif

#module codegen
#       ifndef TOOLKIT
#               error No Toolkit
#       endif
#       ifndef GROUPS
#               error No group names
#       endif
#       def     GenerateGroupCode(void)
	LoadFile(group.code)
#       enddef

#       def    GenerateControlCode(type)
#               assign CNAME Literal(type)_control
#               define CT type
		LoadFile(control.code)
#       enddef

#       def CheckClientServer(void)
#               for CB in SERVERTABLE
#                       if StructDef(CB.D_ClientServer)
#                               define DO_SERVER_CODE 1
#                       endif
#               endfor
#       enddef

#       def handleControl(Gel)
		LoadModule(Gel.type)
		GenerateControlCode(Gel.type)
#       enddef

#       def handleHiddenControl(Gel)
#               define USES_HIDDEN_CONTROLS
#               if GENERATE_HIDDEN_CONTROLS
			handleControl(Gel)
#               endif
#       enddef

#       def handleControlModule(Gel)
#               if Gel.isHiddenField
			handleHiddenControl(Gel)
#               else
			handleControl(Gel)
#               endif
#       enddef


#       def Generate(void)
#               assign LOADED_CONTROLS {}
		CheckClientServer()
#               for GROUP in GROUPS
#                  for Gel in GROUP.elements
#                       if !Matches(ALL_MAPS,.*Gel.type.*)
#                               assign *Gel.type MAP_ANY
#                               assign EXTRACONTROL_NAME Gel.controltype
#                       endif
#                       undef DO_CONTROL_SERVER_CODE
#                       if Gel.isAppElement
#                               define DO_CONTROL_SERVER_CODE 1
#                       endif
#                       assign EXTNAME  Gel
#                       assign EXTVALUE Gel.value
#                       if !Matches(LOADED_CONTROLS,.*{Gel.type}.*)
				handleControlModule(Gel)
#                               assignappend LOADED_CONTROLS {Gel.type}
#                       endif
#                  endfor
		   GenerateGroupCode()
#               endfor
#       enddef

#endmodule

DEBUG(generating)
codegen.Generate()
DEBUG(end of codegen.cmd)
##message <- codegen.cmd
