#include "Awt.m"
#include "ListBase.m"

#module List
#bind   ListBase
#bind   Awt

#def ExtraHeaders(void)
#enddef
#def ExtraMethods(void)
#       ifdef USE_JAVA_10
GetListItems()

RemoveAllItems()
#       endif
#enddef

#def GetListItems(void)
private String[] getListItems( List l)
{
	int total = l.countItems();

	if (total == 0)
		return null;

	String[] items = new String[total];
	for (int i = 0; i < total; i++)
		items[i] = l.getItem(i);

	return items;
}
#enddef

#def RemoveAllItems(xxx)
private void removeAllItems( List l)
{
	int total = l.countItems();

	if (total == 0)
		return;
	l.delItems(0, total);
}
#enddef

#include "awtprelude.std"

#define MyType  List

#def    awt.SelectedItems.get(w)
	return w.getSelectedItems() ;
#enddef

#def    awt.Items.get(w)
#       ifdef USE_JAVA_10
	return getListItems( w);
#       else
	return w.getItems() ;
#       endif
#enddef


#def    awt.SelectedItems.set(w,values)
	List  l = w ;
#       ifdef USE_JAVA_10
	String[] items = getListItems( l) ;
#       else
	String[] items = l.getItems() ;
#       endif
	boolean found ;
	for ( int j=0; j < items.length; j++ )  {
		found = false ;
		for ( int i=0; i < values.length && !found; i++ ) {
			if ( items[j].equals( values[i] ) )
				found = true ;
		}
	    // FIXME for some reason these are not having any effect; might
	    // be the index, might be something else...
		if ( found )
			l.select( j ) ;
		else
			l.deselect( j ) ;
	}
#enddef

#def    awt.Items.set(w,values)
	List  l = w ;
#       ifdef USE_JAVA_10
	removeAllItems(l);
	for ( int j=0; j < values.length; j++ )
		l.addItem( values[j] ) ;
#       else
	l.removeAll();
	for ( int j=0; j < values.length; j++ )
		l.add( values[j] ) ;
#       endif
#enddef

#include "BINDING/Literal(Li)st.m"

#endmodule
