
`#include <windows.h>
typedef struct tdata_s
{
	UINT tid;
	FARPROC mycall;
	void * mydata;
	struct tdata_s * next;
} TimerData;

static TimerData * tdata = (TimerData*)0;

static
void
registerMyTimerCall( UINT tid, FARPROC myproc, void * data)
{
	TimerData * td = (TimerData*) malloc ((unsigned) sizeof(TimerData));
	td->tid    = tid;
	td->mycall = myproc;
	td->mydata = data;
	td->next   = tdata;

	tdata = td;

	return;
}

static
FARPROC
getMyTimerData( UINT tid, void ** data)
{
	TimerData * td;
	TimerData * prev = (TimerData*)0;
	FARPROC fp = (FARPROC)0;
	KillTimer( NULL, tid);

	for (td = tdata; td; td = td->next) {
		if (td->tid == tid)
			break;
		prev = td;
	}
	if (!td)
		return (FARPROC)0;
	fp = td->mycall;
	*data = td->mydata;

	if (prev)
		prev->next = td->next;
	else
		tdata = td->next;
	(void) free ((void*) td);

	return fp;
}


typedef void (*scTimerCall)(void*); 
static int registerMyTimerProc( Literal(HAN)DLE , FARPROC , void * , int);

static
UINT FAR PASCAL
TimerProc( HWND hwnd, UINT message, UINT wParam,LONG lParam)
{
	void * data;
	scTimerCall fp;

	fp = (scTimerCall)getMyTimerData(wParam, &data); 

	if (!fp)
		return 0;
	(*fp)( data);

	return 1;
}

static
int
registerMyTimerProc( Literal(HAN)DLE hInstance, FARPROC myproc, void * mydata, int time) 
{
	static Literal(HAN)DLE   hInst = (Literal(HAN)DLE)0; 
	static FARPROC  myTimerProc = (FARPROC)0;
	UINT tid;

	if (hInstance)
		hInst = hInstance;
	if (!hInst)
		return 0;
	if (!myTimerProc)
		myTimerProc = MakeProcInstance( (FARPROC)TimerProc, hInst);

	if (!myproc)
		return 0;

	tid = SetTimer( NULL, 0, (time), (TIMERPROC) myTimerProc);
	if (!tid)
		return 0;

	registerMyTimerCall( tid, myproc, mydata);

	return 1;
}

void
scSetCallInstance( Literal(HAN)DLE hInstance)
{
	registerMyTimerProc( hInstance, (FARPROC)0, 0, 0);
}

extern FAR void rePollServer(void*,void*);

void
setCallTimer (void* odata, int waittime)
{
	waittime = waittime * 1000; /* seconds not milliseconds */

	registerMyTimerProc( NULL, (FARPROC)rePollServer, (void*)odata, waittime);
}

/* example

	registerMyTimerProc( hInstance, (FARPROC)0, 0, 0);
	registerMyTimerProc( NULL, mycall, "hallo", 5);

*/
