#include "Motif.m"
#include "ComboBoxBase.m"
#include "XmStringUtils.m"

#module   ComboBox
#bind     ComboBoxBase
#bind     XmStringUtils
#bind     Motif

#def ExtraHeaders(void)
`#include "Xm/Literal(Combo)Box.h"
#enddef

#include "motifprelude.std"

#def    motif.Value.get(w)
	XmString xms = (XmString) 0 ;
	char    *val = (char *) 0 ;

	getAnyXmString(w, XmNselectedItem, xms) ;
	cvtXmStringToText(xms, val) ;
	return val ;
#enddef

#def    motif.Value.set(w,val)
	XmString xms = (XmString) 0 ;
	cvtTextToXmString(val, xms) ;
	setAnyXmString(w, XmNselectedItem, xms) ;
	freeXmString(xms) ;
#enddef

#def    motif.Items.get(w)
        XmStringTable xmst  = (XmStringTable) 0 ;
        int           cnt   = 0 ;
        char       **values = (char **) 0 ;

        XtVaGetValues(w, XmNitemCount, &cnt,
                         XmNitems,     &xmst,
			 NULL) ;

        XmStringUtils.cvtXmStringTableToStringArray(xmst,values,cnt) ;

        return values ;
#enddef

#def    motif.Items.set(w,sdata)
        XmStringTable xmst = (XmStringTable) 0 ;
        int           cnt  = 0 ;

        XmStringUtils.cvtStringArrayToXmStringTable(sdata,xmst,cnt)
        
	XtVaSetValues(w, XmNitemCount, cnt,
                         XmNitems,     xmst,
			 NULL) ;
        
	XmStringUtils.freeXmStringTable(xmst,cnt)
#enddef

#include "BINDING/Literal(Com)boBox.m"

#endmodule
