#include "Motif.m"
#include "ListBase.m"
#include "XmStringUtils.m"

#module List
#bind   ListBase
#bind   Motif

#def ExtraHeaders(void)
`#include "Xm/L`ist.h"
#enddef

#include "motifprelude.std"

#def    getListItems(w,res,value)
	XmStringTable xmst = (XmStringTable)0;
	int           cnt  = 0;
	Arg           av[3];
	Cardinal      ac   = 0;

	XtSetArg(av[ac],XmN`res`Count, &cnt); ac++;
	XtSetArg(av[ac],XmN`res`s, &xmst); ac++;

	XtGetValues( w, av, ac);
	XmStringUtils.cvtXmStringTableToStringArray(xmst,value,cnt);
#enddef

#def    setListItems(w,res,n,sdata)
	XmStringTable xmst = (XmStringTable)0;
	int           cnt  = 0;
	Arg           av[4];
	Cardinal      ac   = 0;
	/* 1= w 2= res 3= n 4= sdata */

	XmStringUtils.cvtStringArrayToXmStringTable(sdata,xmst,cnt)
	XtSetArg(av[ac],XmN`res`Count, cnt); ac++;
#       if n
	XtSetArg(av[ac],XmN`visibleItemCount, cnt); ac++;
#       endif
	XtSetArg(av[ac],XmN`res`s, xmst); ac++;
	XtSetValues( w, av, ac);
	XmStringUtils.freeXmStringTable(xmst,cnt)
#enddef

#def    motif.SelectedItems.get(w)
	char ** values = (char**)0;
	getListItems(w,selectedItem,values)

	return values;
#enddef

#def    motif.Items.get(w)
	char ** values = (char**)0;

	getListItems(w,item,values)
	return values;
#enddef


#def    motif.SelectedItems.set(w,sdata)
	setListItems(w,selectedItem,0,sdata)
#enddef

#def    motif.Items.set(w,sdata)
	setListItems(w,item,1,sdata)
#enddef

#include "BINDING/Literal(Li)st.m"

#endmodule
