#include "Motif.m"
#include "OptionMenuBase.m"
#include "XmMenu.m"

#module OptionMenu
#bind   OptionMenuBase
#bind   XmMenu
#bind   Motif

#def ExtraHeaders(void)
`#include "Xm/RowColumn.h"
`#include "sc_groups_`BINDING`.h"
#enddef

#include "motifprelude.std"

#def    motif.Label.get(w)
	char * lbl = (char*)0;
	Widget l   = XmOptionLabelGadget(w);

	getLabelString(l,lbl)

	return lbl;
#enddef

#def    motif.Label.set(w,y)
	Widget l = XmOptionLabelGadget(w);

	setLabelString(l,y)
#enddef

#def    motif.SelectionByName.get(w)
	char * selname = (char*)0;

	getSelectedOptionByName(w,selname)

	return selname;
#enddef

#def    setOption(w,selw)
	/* optionmenu set option */
	setMenuHistory(w,selw)
#enddef

#def    motif.SelectionByName.set(w,y)
	Widget selwidget = (Widget)0;

	findSelectedOptionByName(w,y,selwidget)
	setOption(w,selwidget)
#enddef

#def    motif.SelectionByIndex.get(w)
	int selix = -1;
	getSelectedOptionByIndex(w,selix)
	return selix;
#enddef

#def    motif.SelectionByIndex.set(w,y)
	Widget selwidget = (Widget)0;

	findSelectedOptionByIndex(w,y,selwidget)
	setOption(w,selwidget)
#enddef

#def ExtraFooter(ignoreme)

void
sc_optionentry_callback(Widget w, XtPointer client_data, XtPointer xt_call_data)
{
	XmRowColumnCallbackStruct *call_data = (XmRowColumnCallbackStruct *) xt_call_data;
	Arg args[4];
	Cardinal ac = 0;
#if Matches(BINDING,cpp)
	typedef void (*icall_f)( Widget, XtPointer, XtPointer);
	sc_data_c * d  = (sc_data_c*) client_data;
	icall_f vf = (icall_f)d->getIndirection();
#else
	sc_data_t * d = (sc_data_t*) client_data;
	void_f vf = d->icallout;
#endif


	XtSetArg( args[ac], XmNmenuHistory, call_data->widget); ac++;
	XtSetValues( XtParent(XtParent(w)), args, ac);

	if (!vf)
		return;

	(*vf)( w, client_data, xt_call_data);
}
#enddef

#include "BINDING/Literal(Optio)nMenu.m"

#endmodule
