#include "XmStringUtils.m"

#module XmMenu
#bind   XmStringUtils

#def getMenu(w,menu)
{ /* getMenu */
	int    n = 0;
	Arg args[2];

	XtSetArg( args[n], XmNsubMenuId, &menu); n++;
	XtGetValues( w, args, n);
} /* end getMenu */
#enddef

#def getMenuHistory(menu,wid)
{ /* getMenuHistory */
	Arg args[2];
	Cardinal ac = 0;

	wid = (Widget)0;

	XtSetArg( args[ac], XmNmenuHistory, &wid); ac++;
	XtGetValues( menu, args, ac);
} /* end getMenuHistory */
#enddef

#def setMenuHistory(menu,wid)
{ /* setMenuHistory */
	Arg args[2];
	Cardinal ac = 0;

	XtSetArg( args[ac], XmNmenuHistory, wid); ac++;
	XtSetValues( menu, args, ac);
} /* end setMenuHistory */
#enddef

#def setRadioSelection(wid)
if (wid)
	XmToggleButtonGadgetSetState(wid, True, True);
#enddef

#def getSelectedOptionByName(widget,name)
{ /* getSelectedOptionByName */
	Widget selwidget = (Widget)0;

	getMenuHistory(widget,selwidget)
	if (selwidget)
		getLabelString(selwidget,name);
} /* end getSelectedOptionByName */
#enddef

#def findSelectedOptionByName(widget,name,selwidget)
{ /* find SelectedOptionByName */
	int cnt = 0;
	WidgetList wl = (WidgetList)0;

	selwidget = (Widget)0;
	getSelectionChildrenList(widget,wl,cnt)
	if (wl)
		findWidgetInList(name,wl,cnt,selwidget)
} /* end setSelectedOptionByName */
#enddef

#def getSelectedOptionByIndex(widget,ix)
{ /* getSelectedOptionByIndex */
	Widget selwidget = (Widget)0;
	int cnt       = 0;
	WidgetList wl = (WidgetList)0;

	getMenuHistory(widget,selwidget)
	if (selwidget) {
		ix = 0;
		getSelectionChildrenList(widget,wl,cnt)
		if (wl && (cnt > 0))
			findIndexInList(wl,cnt,selwidget,ix)
	}
} /* end getSelectedOptionByIndex */
#enddef

#def findSelectedOptionByIndex(widget,ix,selwidget)
{ /* setSelectedOptionByIndex */
	int cnt = 0;
	WidgetList wl = (WidgetList)0;

	selwidget = (Widget)0;
	getSelectionChildrenList(widget,wl,cnt)
	if (wl && (cnt > ix))
		selwidget = wl[ix];
} /* end setSelectedOptionByIndex */
#enddef

#def getSelectionChildrenList(w,children,num)
{ /* getSelectionChildrenList */
	Widget menu = (Widget)0;

	getMenu(w,menu)
	if (menu)
		getWidgetChildren(menu,children,num)
} /* end getSelectionChildrenList */
#enddef

#def getRadioSelectionChildrenList(w,children,num)
{ /* getRadioSelectionChildrenList */
	getWidgetChildren(w,children,num)
} /* end getRadioSelectionChildrenList */
#enddef

#def getWidgetChildren(widget,children,numch)
{ /* getWidgetChildren */
	int n = 0;
	Arg args[3];
	children    = (WidgetList)0;
	numch = 0;

	XtSetArg( args[n], XtNnumChildren, &numch); n++;
	XtGetValues( widget, args, n);

	if (numch > 0) {
		n = 0;

		XtSetArg( args[n], XtNchildren, &children); n++;
		XtGetValues( widget, args, n);
	}
} /* end getWidgetChildren */
#enddef

#def    findWidgetInList(name,wl,cnt,selw)
{ /* findWidgetInList */
	char * tmps = (char*)0;
	for( ; !selw && cnt-- > 0; wl++) {
		if (!*wl)
			continue;
		getLabelString(*wl,tmps)
		if (tmps && (strcmp( tmps, name) == 0))
			selw = *wl;
		freeString(tmps);
	}
} /* end findWidgetInList */
#enddef

#def    findIndexInList(wl,cnt,selw,ix)
{ /* findIndexInList */
	for( ; cnt-- > 0; wl++,ix++) {
		if (!*wl)
			continue;
		if (*wl == selw)
			break;
	}
} /* end findIndexInList */
#enddef

#endmodule
