#module XmStringUtils

#def    setLabelString(w,val)
{ /* setLabelString */
	XmString xms;
	cvtTextToXmString(val,xms)
	setAnyXmString(w,XmNlabelString,xms)
	freeXmString(xms)
} /* end setLabelString */
#enddef

#def getAnyXmString(w,res,xs)
{ /* getAnyXmString */
	Cardinal n = 0;
	Arg args[2];

	XtSetArg(args[n], res, &xs); n++;
	XtGetValues(w, args, n);
} /* getAnyXmString */
#enddef

#def    getLabelString(w,val)
{ /* getLabelString */
	XmString xms = (XmString)0;

	getAnyXmString(w,XmNlabelString,xms)
	cvtXmStringToText(xms,val)
	freeXmString(xms)
} /* end getLabelString */
#enddef


#def setAnyXmString(w,res,xs)
{ /* setAnyXmString */
	Cardinal n = 0;
	Arg args[2];

	XtSetArg(args[n], res, xs); n++;
	XtSetValues(w, args, n);
} /* end setAnyXmString */
#enddef

#def cvtXmStringToText(xs,txt)
`#if       (XmVERSION > 1)
	txt = (char *) XmStringUnparse(xs, NULL, XmCHARSET_TEXT, XmCHARSET_TEXT, NULL, 0, XmOUTPUT_ALL) ;
`#else  /* (XmVERSION > 1) */
	XmStringGetLtoR(xs, XmFONTLIST_DEFAULT_TAG, &(txt)) ;
`#endif /* (XmVERSION > 1) */
#enddef

#def cvtTextToXmString(txt,xs)
`#if       (XmVERSION > 1)
	xs = XmStringGenerate((XtPointer)txt, XmFONTLIST_DEFAULT_TAG, XmCHARSET_TEXT, NULL) ;
`#else  /* (XmVERSION > 1) */
	xs = XmStringCreateLtoR(txt,XmFONTLIST_DEFAULT_TAG) ;
`#endif /* (XmVERSION > 1) */
#enddef

#def freeXmString(xs)
if (xs != (XmString)0) { /* freeXmString */
	XmStringFree(xs);
	xs = (XmString)0;
} /* end freeXmString */
#enddef

#def    freeXmStringTable(xmst,cnt)
if (xmst) { /* freeXmStringTable */
	XmStringTable xmd;

	for (xmd=xmst; cnt>0; cnt--, xmd++)
		freeXmString(*xmd)
	freeString(xmst);
} /* end freeXmStringTable */
#enddef

#def cvtXmStringTableToStringArray(xs,txt,cnt)
{ /* cvtXmStringTableToStringArray */
`#if       (XmVERSION > 1)
	txt = (char **) XmStringTableUnparse(xs,
				             cnt,
					     XmFONTLIST_DEFAULT_TAG,
					     XmCHARSET_TEXT,
					     XmCHARSET_TEXT,
					     NULL,
					     0,
					     XmOUTPUT_ALL) ;
`#else  /* (XmVERSION > 1) */
	int i;
	txt = (char**)XtMalloc((unsigned)(cnt+1)*sizeof(char*));

	for (i=0; i < cnt; i++)
		cvtXmStringToText(xs[i],txt[i])
	txt[i] = (char*)0;
`#endif /* (XmVERSION > 1) */
} /* end cvtXmStringTableToStringArray */
#enddef

#def cvtStringArrayToXmStringTable(txt,xs,cnt)
{ /* cvtStringArrayToXmStringTable */
	char **a = (char **) 0;
	/* 1= txt 2= xs 3= cnt */

	for (a=txt; a && *a; a++, cnt++);
`#if       (XmVERSION > 1)
	xs = XmStringTableParseStringArray((XtPointer *)txt, 
					   cnt,
					   XmFONTLIST_DEFAULT_TAG, 
					   XmCHARSET_TEXT, 
					   NULL, 
					   0,
					   (XtPointer) 0) ;
`#else  /* (XmVERSION > 1) */
	xs = (XmStringTable) XtMalloc((unsigned) (cnt)*sizeof(XmStringTable));
	for (a=txt, cnt=0; a && *a; a++, cnt++)
		cvtTextToXmString(*a,xs[cnt]);
`#endif /* (XmVERSION > 1) */
} /* end cvtStringArrayToXmStringTable */
#enddef

#define freeString(s) XtFree((char*)s)

#endmodule
