#include "Swing.m"
#include "OptionMenuBase.m"

#module OptionMenu
#bind   OptionMenuBase
#bind   Swing

#def ExtraHeaders(void)
#enddef

#define MyType Component

#def getHiddenChoice(void)
	protected Choice getHiddenChoiceComponent( Component me)  {
		if ( me instanceof Choice )
			return (Choice) me ;
		if ( !(me instanceof Container) )  {
			// Should never happen
			return null ;
		}
		Component[] kids = ((Container) me).getComponents() ;
		for ( int i=0; i < kids.length; i++ )  {
			if ( kids[i] instanceof Choice )
				return (Choice) kids[i] ;
		}
		return null ;
	}
#enddef
#def getHiddenLabel(void)
	protected Label getHiddenLabelComponent( Component me)  {
		if ( !(me instanceof Panel) )
			return null ;
		Component[] kids = ((Container) me).getComponents() ;
		for ( int i=0; i < kids.length; i++ )  {
			if ( kids[i] instanceof Label )
				return (Label) kids[i] ;
		}
		return null ;
	}
#enddef

#def ExtraMethods(void)
	getHiddenChoice()

	getHiddenLabel()
#enddef

#include "swingprelude.std"

#def    swing.Label.get(w)
	Label l = getHiddenLabelComponent( w) ;
	if ( l == null )
		return null ;
	return l.getText() ;
#enddef

#def    swing.Label.set(w,y)
	Label l = getHiddenLabelComponent( w) ;
	if ( l == null )
		return;  // FIXME?
	l.setText( val ) ;
#enddef

#def    swing.SelectionByName.get(w)
	Choice c = getHiddenChoiceComponent( w) ;
	if ( c == null )
		return null ;
	return c.getSelectedItem() ;
#enddef

#def    swing.SelectionByName.set(w,y)
	Choice c = getHiddenChoiceComponent( w) ;
	if ( c == null )
		return ;
	c.select( y ) ;
#enddef

#def    swing.SelectionByIndex.get(w)
	Choice c = getHiddenChoiceComponent( w) ;
	if ( c == null )
		return -1 ;
	return c.getSelectedIndex() ;
#enddef

#def    swing.SelectionByIndex.set(w,y)
	Choice c = getHiddenChoiceComponent( w) ;
	if ( c == null )
		return ;
	c.select( y ) ;
#enddef

#include "BINDING/Literal(Optio)nMenu.m"

#endmodule
