#include <stdio.h>

#include "sc_groups_c.h"
#include "URL.h"

/* you need to add the SGML.h header file reference*/
#include "SGML.h"

int
myData ( sc_stdcs_t * data, sc_idata_t * idata )
{
	extern SGML_t * scRegisterHTML();
	extern int getlinkinfo();

	mygroup_t * group = (mygroup_t*)data->group;
	InputStream * i   = (*idata->getInputStream)( idata);
	char      * type  = (*idata->getMimeType)(idata);

/* the code you would write starts here*/

	SGML_t * sgm;   /* an opaque handle used by the parser. */
			/* like a FILE* or a DIR* */

	if ( strcmp( type, "text/html") != 0) /* check the mime type of the */
		return -1;                    /* data coming in */

	sgm = scRegisterHTML( type);         /* get a the parser object */
					     /* for that mime type */

	(void) scAddAttrCallback( sgm,  "A", "HREF",   getlinkinfo, "href");
				/* gelinkinfo will gather information on links */
				/* as they appear in the HTML */

	(void) scProcessSGML( sgm, i);
				/* now process the InputStream i */

	showMyLinks( group);
		/* now we have parsed the data, display the results in */
		/* the group->urldata text widget */

/* thats all */

	return 0;
}

/* a data structure to store the link data in */

typedef struct mylinks_s {
	char * link;
	struct mylinks_s * next;
} MyLink_t;

MyLink_t * mylinks     = (MyLink_t*)0;
int        linkbufsize = 0;

/* the callback that handles the HREF attribute in the HTML input stream */

int
getlinkinfo( tag, attr, type, call_data, client_data)
	char * tag;
	char * attr;
	int    type;
	void * call_data;
	void * client_data;
{
	MyLink_t * ml = (MyLink_t*) malloc ((unsigned) sizeof(MyLink_t));

	ml->next = mylinks;
	mylinks  = ml;
	ml->link = strdup( call_data);
	linkbufsize += strlen(call_data) + 1;

	return 0;
}

/* a simple routine that puts the links in a single string
   and dumps them in the group->urldata text widget

   only mild complication is that it does clean up the link list
   after it has processed the data */

int
showMyLinks( mygroup_t* group)
{
	char * tbuf = (char*) malloc ((unsigned)(linkbufsize+1) * sizeof(char));
	char * tptr = tbuf;
	MyLink_t * ml;
	MyLink_t * dl;

	for (ml = mylinks; ml;) {
		tptr   += strlen(strcpy( tptr, ml->link));
		*tptr++ = '\n';
		dl = ml;
		ml = ml->next;
		free(dl->link);
		free(dl);
	}
	*tptr++ = '\0';
	SC_SET(Value,group->urldata,tbuf);
	free( tbuf);

	mylinks = (MyLink_t*)0;

	return 0;
}
