#include <stdio.h>

#include "X11/Xatom.h"
#include "X11/Intrinsic.h"
#include "X11/Shell.h"

#include "Xm/Xm.h"
#include "Xm/Label.h"

#include "live.h"

int
xmlabel_getter( GroupData_t * gd, int_f printfun)
{
	Widget w = gd->widget;
	char * val = (char*)0;
	{ /* getLabelString */
		XmString xms = (XmString)0;

		{ /* getAnyXmString */
			Cardinal n = 0;
			Arg args[2];

			XtSetArg( args[n], XmNlabelString, &xms); n++;
			XtGetValues( w, args, n);
		} /* getAnyXmString */

#if       (XmVERSION > 1)
		val = (char *) XmStringUnparse(xms, NULL, XmCHARSET_TEXT, XmCHARSET_TEXT, NULL, 0, XmOUTPUT_ALL) ;
#else  /* (XmVERSION > 1) */
		XmStringGetLtoR(xms,XmFONTLIST_DEFAULT_TAG, &(val));
#endif /* (XmVERSION > 1) */

		if (xms != (XmString)0) { /* freeXmString */
			XmStringFree(xms);
			xms = (XmString)0;
		} /* end freeXmString */
	} /* end getLabelString */
	if (!val)
		return 0;

	(*printfun)( val);
	return 1;
}

void
xmlabel_reader( GroupData_t * gd, char * toeol, string_f readfun)
{
	if (toeol)
		gd->value = XtNewString( toeol);
	else
		gd->value = (char*)0;
}

void
xmlabel_setter ( GroupData_t * gd)
{
	Widget w   = gd->widget;
	char * val = gd->value;
	XmString xms;

	if (!val)
		val = "";

#if       (XmVERSION > 1)
	xms = XmStringGenerate((XtPointer) val, XmFONTLIST_DEFAULT_TAG, XmCHARSET_TEXT, NULL);
#else  /* (XmVERSION > 1) */
	xms = XmStringCreateLtoR(val,XmFONTLIST_DEFAULT_TAG);
#endif /* (XmVERSION > 1) */

	{ /* setAnyXmString */
		Cardinal n = 0;
		Arg args[2];

		XtSetArg( args[n], XmNlabelString, xms); n++;
		XtSetValues( w, args, n);
	} /* end setAnyXmString */
	if (xms != (XmString)0) { /* freeXmString */
		XmStringFree(xms);
		xms = (XmString)0;
	} /* end freeXmString */
	if (gd->value) {
		XtFree((void*) gd->value);
		gd->value = (char*)0;
	}
}
