#include <stdio.h>

#include "X11/Xatom.h"
#include "X11/Intrinsic.h"
#include "X11/Shell.h"

#include "Xm/Xm.h"

#include "live.h"


int
xmlist_internal_getter( Widget w, void_f printfun)
{
	char ** values = (char**)0;
	char * rval;
	int i;
	char buf[5];

	XmStringTable xmst = (XmStringTable)0;
		int           cnt  = 0;
		Arg           av[3];
		Cardinal      ac   = 0;

		XtSetArg(av[ac],XmNselectedItemCount, &cnt); ac++;
		XtSetArg(av[ac],XmNselectedItems, &xmst); ac++;

		XtGetValues( w, av, ac);
		{ /* cvtXmStringTableToStringArray */
			int i;
			values = (char**)XtMalloc((unsigned)(cnt+1)*sizeof(char*));

			for (i=0; i < cnt; i++) {

#if       (XmVERSION > 1)
				values[i] = (char *) XmStringUnparse(xmst[i], 
							             NULL, 
							             XmCHARSET_TEXT, XmCHARSET_TEXT, 
								     NULL, 0, XmOUTPUT_ALL) ;
#else  /* (XmVERSION > 1) */
				XmStringGetLtoR(xmst[i], XmFONTLIST_DEFAULT_TAG, &(values[i]));
#endif /* (XmVERSION > 1) */
			}

			values[cnt] = (char*)0;
		} /* end cvtXmStringTableToStringArray */;

	(void) sprintf( buf, "%d", cnt);
	(*printfun)( buf);
	for (i = 0; i < cnt; i++)
		(*printfun)(values[i]);

	for (i = 0; i < cnt; i++)
		(void) XtFree(values[i]);

	(void) XtFree( (void*)values);

	return 1;
}

int
xmlist_getter ( GroupData_t * gd, void_f printfun)
{
	Widget w = gd->widget;

	return xmlist_internal_getter( w, printfun);
}

void
xmlist_reader( GroupData_t * gd, char * toeol, string_f readfun)
{
	int i = atoi(toeol);
	int j;
	char ** values;

	if (i == 0)
		return;

	values = (char**) XtMalloc ((unsigned) (i+2) * sizeof(char*));
	values[0] = (char*)i;

	for (j = 1; j <= i; j++) {
		values[j] = (*readfun)();
		if (!values[j])
			break;
		values[j] = XtNewString(values[j]);
	}
	values[j] = (char*)0;

	gd->value = (char*)values;

	return;
}


void
xmlist_setter( GroupData_t * gd)
{
	Widget w    = gd->widget;
	char ** val = (char**)(gd->value);
	XmStringTable xmst = (XmStringTable)0;
	int           cnt;
	Arg           av[4];
	Cardinal      ac   = 0;
	int     i;

	if (!val || !*val)
		return;

	cnt = (int)(*val);

	if (!cnt)
		return;

	{ /* cvtStringArrayToXmStringTable */
		char ** a = val+1;
		xmst = (XmStringTable) XtMalloc((unsigned) (cnt)*sizeof(XmStringTable));
		for ( i = 0; i < cnt; i++) {
#if       (XmVERSION > 1)
			xmst[i] = XmStringGenerate((XtPointer) a[i], XmFONTLIST_DEFAULT_TAG, XmCHARSET_TEXT, NULL);
#else  /* (XmVERSION > 1) */
			xmst[i] = XmStringCreateLtoR(a[i], XmFONTLIST_DEFAULT_TAG);
#endif /* (XmVERSION > 1) */
		}
		/* and free it !!!! */
	} /* end cvtStringArrayToXmStringTable */
	XtSetArg(av[ac],XmNselectedItemCount, cnt); ac++;
	XtSetArg(av[ac],XmNselectedItems, xmst); ac++;
	XtSetValues( w, av, ac);
	if (xmst) { /* freeXmStringTable */
		XmStringTable xmd;

		for (xmd=xmst; cnt>0; cnt--, xmd++)
			if (*xmd != (XmString)0) { /* freeXmString */
				XmStringFree(*xmd);
				*xmd = (XmString)0;
			} /* end freeXmString */
		XtFree((char*)xmst);
	} /* end freeXmStringTable */
	if (gd->value) {
		val = (char**)gd->value;
		val++;
		while (val && *val) {
			XtFree((void*) *val);
			val++;
		}
		XtFree((void*)gd->value);
		gd->value = (char*)0;
	}
}

extern Widget goliveGetWorkAreaWidget();

int
xmscrolledlist_getter( GroupData_t * gd, void_f printfun)
{
	Widget w = gd->widget;

	w = goliveGetWorkAreaWidget(w);
	if (!w)
		return 0;
	return xmlist_internal_getter( w, printfun);
}

void
xmscrolledlist_reader( GroupData_t * gd, char * toeol, string_f readfun)
{
	xmlist_reader( gd, toeol, readfun);
}


void
xmscrolledlist_setter( GroupData_t * gd)
{
	Widget origw = gd->widget;
	Widget w = goliveGetWorkAreaWidget(origw);
	if (w) {
		gd->widget = w;
		xmlist_setter( gd);
		gd->widget = origw;
	}
}
