#include <stdio.h>

#include "X11/Xatom.h"
#include "X11/Intrinsic.h"
#include "X11/Shell.h"

#include "Xm/Xm.h"

#include "live.h"

int
optionmenu_getter ( GroupData_t * gd, void_f printfun)
{
	Widget w  = gd->widget;
	int selix = -1;
	char buf[5];

	{ /* getSelectedOptionByIndex */
		Widget selwidget = (Widget)0;
		int cnt       = 0;
		WidgetList wl = (WidgetList)0;

		{ /* getMenuHistory */
			Arg args[2];
			Cardinal ac = 0;

			selwidget = (Widget)0;

			XtSetArg( args[ac], XmNmenuHistory, &selwidget); ac++;
			XtGetValues( w, args, ac);
		} /* end getMenuHistory */
		if (selwidget) {
			selix = 0;
			{ /* getOptionMenuList */
				Widget menu = (Widget)0;

				{ /* getMenu */
					int    n = 0;
					Arg args[2];

					XtSetArg( args[n], XmNsubMenuId, &menu); n++;
					XtGetValues( w, args, n);
				} /* end getMenu */
				if (menu)
					{ /* getWidgetChildren */
						int n = 0;
						Arg args[3];
						wl    = (WidgetList)0;
						cnt = 0;

						XtSetArg( args[n], XtNnumChildren, &cnt); n++;
						XtGetValues( menu, args, n);

						if (cnt > 0) {
							n = 0;

							XtSetArg( args[n], XtNchildren, &wl); n++;
							XtGetValues( menu, args, n);
						}
					} /* end getWidgetChildren */
			} /* end getOptionMenuList */
			if (wl && (cnt > 0))
				{ /* findIndexInList */
					for( ; cnt-- > 0; wl++,selix++) {
						if (!*wl)
							continue;
						if (*wl == selwidget)
							break;
					}
				} /* end findIndexInList */
		}
	} /* end getSelectedOptionByIndex */

	(void) sprintf ( buf, "%d", selix);
	(*printfun)( buf);

	return 1;
}

void
optionmenu_reader( GroupData_t * gd, char * toeol, string_f readfun)
{
	if (toeol) {
		gd->value = XtNewString( toeol);
	} else
		gd->value = (char*)0;
}

void
optionmenu_setter( GroupData_t * gd)
{
	Widget w    = gd->widget;
	char * ival = gd->value;

	Widget selwidget = (Widget)0;
	int val = (ival ? atoi(ival) : 0);

	{ /* setSelectedOptionByIndex */
		int cnt = 0;
		WidgetList wl = (WidgetList)0;

		selwidget = (Widget)0;
		{ /* getOptionMenuList */
			Widget menu = (Widget)0;

			{ /* getMenu */
				int    n = 0;
				Arg args[2];

				XtSetArg( args[n], XmNsubMenuId, &menu); n++;
				XtGetValues( w, args, n);
			} /* end getMenu */
			if (menu)
				{ /* getWidgetChildren */
					int n = 0;
					Arg args[3];
					wl    = (WidgetList)0;
					cnt = 0;

					XtSetArg( args[n], XtNnumChildren, &cnt); n++;
					XtGetValues( menu, args, n);

					if (cnt > 0) {
						n = 0;

						XtSetArg( args[n], XtNchildren, &wl); n++;
						XtGetValues( menu, args, n);
					}
				} /* end getWidgetChildren */
		} /* end getOptionMenuList */
		if (wl && (cnt > val))
			selwidget = wl[val];
	} /* end setSelectedOptionByIndex */
	{ /* setMenuHistory */
	Arg args[2];
	Cardinal ac = 0;

	XtSetArg( args[ac], XmNmenuHistory, selwidget); ac++;
	XtSetValues( w, args, ac);
} /* end setMenuHistory */

	if (gd->value) {
		XtFree((void*) gd->value);
		gd->value = (char*)0;
	}
}
