#include <stdio.h>

#include "X11/Xatom.h"
#include "X11/Intrinsic.h"
#include "X11/Shell.h"

#include "Xm/Xm.h"
#include "live.h"

int
radiobox_getter( GroupData_t * gd, void_f printfun)
{
	Widget w = gd->widget;
	char buf[5];
	int selix = -1;
	{ /* getSelectedOptionByIndex */
		Widget selwidget = (Widget)0;
		int cnt       = 0;
		WidgetList wl = (WidgetList)0;

		{ /* getMenuHistory */
			Arg args[2];
			Cardinal ac = 0;

			selwidget = (Widget)0;

			XtSetArg( args[ac], XmNmenuHistory, &selwidget); ac++;
			XtGetValues( w, args, ac);
		} /* end getMenuHistory */
		if (selwidget) {
			selix = 0;
			{ /* getWidgetChildren */
				int n = 0;
				Arg args[3];
				wl    = (WidgetList)0;
				cnt = 0;

				XtSetArg( args[n], XtNnumChildren, &cnt); n++;
				XtGetValues( w, args, n);

				if (cnt > 0) {
					n = 0;

					XtSetArg( args[n], XtNchildren, &wl); n++;
					XtGetValues( w, args, n);
				}
			} /* end getWidgetChildren */
			if (wl && (cnt > 0))
				{ /* findIndexInList */
					for( ; cnt-- > 0; wl++,selix++) {
						if (!*wl)
							continue;
						if (*wl == selwidget)
							break;
					}
				} /* end findIndexInList */
		}
	} /* end getSelectedOptionByIndex */

	(void) sprintf ( buf, "%d", selix);
	(*printfun)( buf);

	return 1;
}

void
radiobox_reader( GroupData_t * gd, char * toeol, string_f readcall)
{
	if (toeol)
		gd->value = XtNewString( toeol);
	else
		gd->value = (char*)0;
}

void
radiobox_setter( GroupData_t * gd)
{
	Widget w    = gd->widget;
	char * ival = gd->value;
	Widget selwidget = (Widget)0;
	int val = (ival ? atoi(ival) : 0);


	{ /* setSelectedOptionByIndex */
		int cnt = 0;
		WidgetList wl = (WidgetList)0;

		selwidget = (Widget)0;
	{ /* getWidgetChildren */
		int n = 0;
		Arg args[3];
		wl    = (WidgetList)0;
		cnt = 0;

		XtSetArg( args[n], XtNnumChildren, &cnt); n++;
		XtGetValues( w, args, n);

		if (cnt > 0) {
			n = 0;

			XtSetArg( args[n], XtNchildren, &wl); n++;
			XtGetValues( w, args, n);
		}
	} /* end getWidgetChildren */
		if (wl && (cnt > val))
			selwidget = wl[val];
	} /* end setSelectedOptionByIndex */
	/* radiobox set option */
		if (selwidget)
			XmToggleButtonGadgetSetState(selwidget, True, True);
}
