#include <stdio.h>

#include "X11/Xatom.h"
#include "X11/Intrinsic.h"
#include "X11/Shell.h"

#include "Xm/Xm.h"

#include "live.h"

int
xmscale_getter ( GroupData_t * gd, void_f printfun)
{
	Widget w = gd->widget;
	char buf[5];
	int value = 0;
	XmScaleGetValue( w, &(value));
	(void) sprintf( buf, "%d", value);
	(*printfun)( buf);

	return 1;
}

void
xmscale_reader( GroupData_t * gd, char * toeol, string_f readfun)
{
	if (toeol)
		gd->value = XtNewString( toeol);
	else
		gd->value = (char*)0;
}

void
xmscale_setter ( GroupData_t * gd)
{
	Widget w    = gd->widget;
	char * ival = gd->value;
	int val     = (ival ? atoi(ival) : 0);

	XmScaleSetValue(w, val);

	if (gd->value) {
		XtFree((void*) gd->value);
		gd->value = (char*)0;
	}
}
