#ifndef _RESOURCES_H
#define _RESOURCES_H 1

#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>

#include "xdSoftObject.h"

static void xdSoftObjectGetValues();
static void xdSoftObjectSetValues();

static void initCallback();
static void destroyCallback();
static void startCallback();
static void stopCallback();


extern int xmtext_getter();
extern void   xmtext_reader();
extern void   xmtext_setter();
extern int xmscrolledtext_getter();
extern void   xmscrolledtext_reader();
extern void   xmscrolledtext_setter();
extern int xmtogglebutton_getter();
extern void   xmtogglebutton_reader();
extern void   xmtogglebutton_setter();
extern int optionmenu_getter();
extern void   optionmenu_reader();
extern void   optionmenu_setter();
extern int radiobox_getter();
extern void   radiobox_reader();
extern void   radiobox_setter();
extern int xmlist_getter();
extern void   xmlist_reader();
extern void   xmlist_setter();
extern int xmscrolledlist_getter();
extern void   xmscrolledlist_reader();
extern void   xmscrolledlist_setter();
extern int xmscale_getter();
extern void   xmscale_reader();
extern void   xmscale_setter();
extern int xmlabel_getter();
extern void   xmlabel_reader();
extern void   xmlabel_setter();


typedef struct {
	int       type;
	XtPointer setValues;
	XtPointer getValues;
	XtPointer engineSetValues;
	XtPointer engineGetValues;
	/*-----------------------*/
	XtPointer initCallback;
	XtPointer destroyCallback;
	XtPointer startCallback;
	XtPointer stopCallback;
	/*-----------------------*/
	XtPointer getXmText;
	XtPointer readXmText;
	XtPointer setXmText;
	XtPointer getXmScrolledText;
	XtPointer readXmScrolledText;
	XtPointer setXmScrolledText;
	XtPointer getXmToggleButton;
	XtPointer readXmToggleButton;
	XtPointer setXmToggleButton;
	XtPointer getXmOptionMenu;
	XtPointer readXmOptionMenu;
	XtPointer setXmOptionMenu;
	XtPointer getXmRadioBox;
	XtPointer readXmRadioBox;
	XtPointer setXmRadioBox;
	XtPointer getXmList;
	XtPointer readXmList;
	XtPointer setXmList;
	XtPointer getXmScrolledList;
	XtPointer readXmScrolledList;
	XtPointer setXmScrolledList;
	XtPointer getXmScale;
	XtPointer readXmScale;
	XtPointer setXmScale;
	XtPointer getXmLabel;
	XtPointer readXmLabel;
	XtPointer setXmLabel;
} data_t;

static data_t data;

static
XtResource resources[] = {
	{
		XDNtype, XDCType, XtRInt, sizeof(int),
		XtOffsetOf(data_t,type), XtRImmediate,
		(XtPointer)XD_SOFT_CALLBACK_OBJECT
	},
	{
		XDNxdsoftSetValues, XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,setValues), XtRImmediate,
		(XtPointer)xdSoftObjectSetValues
	},
	{
		XDNxdsoftGetValues, XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,getValues), XtRImmediate,
		(XtPointer)xdSoftObjectGetValues
	},
	{
		XDNsetValues, XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,engineSetValues), XtRPointer,
		(XtPointer)0
	},
	{
		XDNgetValues, XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,engineGetValues), XtRPointer,
		(XtPointer)0
	},
	/* module housekeeping */
	{
		"initCallback", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,initCallback), XtRImmediate,
		(XtPointer)initCallback
	},
	{
		"destroy", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,destroyCallback), XtRImmediate,
		(XtPointer)destroyCallback
	},
	{
		"start", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,startCallback), XtRImmediate,
		(XtPointer)startCallback
	},
	{
		"stop", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,stopCallback), XtRImmediate,
		(XtPointer)stopCallback
	},
	/* getters and setters */
	{
		"getXmText", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,getXmText), XtRImmediate,
		(XtPointer)xmtext_getter
	},
	{
		"readXmText", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,readXmText), XtRImmediate,
		(XtPointer)xmtext_reader
	},
	{
		"setXmText", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,setXmText), XtRImmediate,
		(XtPointer)xmtext_setter
	},
	{
		"getXmScrolledText", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,getXmScrolledText), XtRImmediate,
		(XtPointer)xmscrolledtext_getter
	},
	{
		"readXmScrolledText", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,readXmScrolledText), XtRImmediate,
		(XtPointer)xmscrolledtext_reader
	},
	{
		"setXmScrolledText", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,setXmScrolledText), XtRImmediate,
		(XtPointer)xmscrolledtext_setter
	},
	{
		"getXmToggleButton", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,getXmToggleButton), XtRImmediate,
		(XtPointer)xmtogglebutton_getter
	},
	{
		"readXmToggleButton", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,readXmToggleButton), XtRImmediate,
		(XtPointer)xmtogglebutton_reader
	},
	{
		"setXmToggleButton", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,setXmToggleButton), XtRImmediate,
		(XtPointer)xmtogglebutton_setter
	},
	{
		"getXmOptionMenu", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,getXmOptionMenu), XtRImmediate,
		(XtPointer)optionmenu_getter
	},
	{
		"readXmOptionMenu", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,readXmOptionMenu), XtRImmediate,
		(XtPointer)optionmenu_reader
	},
	{
		"setXmOptionMenu", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,setXmOptionMenu), XtRImmediate,
		(XtPointer)optionmenu_setter
	},
	{
		"getXmRadioBox", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,getXmRadioBox), XtRImmediate,
		(XtPointer)radiobox_getter
	},
	{
		"readXmRadioBox", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,readXmRadioBox), XtRImmediate,
		(XtPointer)radiobox_reader
	},
	{
		"setXmRadioBox", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,setXmRadioBox), XtRImmediate,
		(XtPointer)radiobox_setter
	},
	{
		"getXmList", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,getXmList), XtRImmediate,
		(XtPointer)xmlist_getter
	},
	{
		"readXmList", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,readXmList), XtRImmediate,
		(XtPointer)xmlist_reader
	},
	{
		"setXmList", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,setXmList), XtRImmediate,
		(XtPointer)xmlist_setter
	},
	{
		"getXmScrolledList", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,getXmScrolledList), XtRImmediate,
		(XtPointer)xmscrolledlist_getter
	},
	{
		"readXmScrolledList", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,readXmScrolledList), XtRImmediate,
		(XtPointer)xmscrolledlist_reader
	},
	{
		"setXmScrolledList", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,setXmScrolledList), XtRImmediate,
		(XtPointer)xmscrolledlist_setter
	},
	{
		"getXmScale", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,getXmScale), XtRImmediate,
		(XtPointer)xmscale_getter
	},
	{
		"readXmScale", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,readXmScale), XtRImmediate,
		(XtPointer)xmscale_reader
	},
	{
		"setXmScale", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,setXmScale), XtRImmediate,
		(XtPointer)xmscale_setter
	},
	{
		"getXmLabel", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,getXmLabel), XtRImmediate,
		(XtPointer)xmlabel_getter
	},
	{
		"readXmLabel", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,readXmLabel), XtRImmediate,
		(XtPointer)xmlabel_reader
	},
	{
		"setXmLabel", XtCCallback, XtRPointer, sizeof(XtPointer),
		XtOffsetOf(data_t,setXmLabel), XtRImmediate,
		(XtPointer)xmlabel_setter
	},
};

#include "init.h"


#endif
