#include <stdio.h>

#include "X11/Xatom.h"
#include "X11/Intrinsic.h"
#include "X11/Shell.h"

#include "Xm/Xm.h"
#include "Xm/Text.h"

#include "live.h"

int
xmtext_internal_getter( Widget w, void_f printfun)
{
	char * val = XmTextGetString( w);

	if (!val) {
		printf("no data for %s\n", XtName(w));
		return 0;
	}

	(*printfun)( val);
	(void) XtFree( val);

	return 1;
}

int
xmtext_getter( GroupData_t * gd, void_f printfun)
{
	Widget w = gd->widget;
	return xmtext_internal_getter( w, printfun);
}


void
xmtext_reader( GroupData_t * gd, char * toeol, string_f readcall)
{
	if (toeol)
		gd->value = XtNewString( toeol);
	else
		gd->value = (char*)0;
}


void
xmtext_setter( GroupData_t * gd)
{
	Widget w   = gd->widget;
	char * val = gd->value;
	char * p;

	for (p = val; p && *p; p++) {
		if (*p != '\r')
			continue;
		if (*(p+1) && ((*p+1) == '\n'))
			*p = ' ';
		else
			*p = '\n';
	}
	XmTextSetString( w, ( val ? val : ""));
	if (gd->value) {
		XtFree((void*) gd->value);
		gd->value = (char*)0;
	}
}

Widget
goliveGetWorkAreaWidget( Widget w)
{
	Arg av[2];
	Cardinal ac = 0;

	XtSetArg( av[ac], XmNworkWindow, &w); ac++;
	XtGetValues( w, av, ac);

	return w;
}


int
xmscrolledtext_getter( GroupData_t * gd, void_f printcall)
{
	Widget w = gd->widget;
	w = goliveGetWorkAreaWidget(w);
	if (!w)
		return 0;

	return xmtext_internal_getter( w, printcall);
}

void
xmscrolledtext_reader( GroupData_t * gd, char * toeol, string_f readcall)
{
	if (toeol)
		gd->value = XtNewString( toeol);
	else
		gd->value = (char*)0;
}



void
xmscrolledtext_setter( GroupData_t * gd)
{
	Widget w   = gd->widget;
	char * val = gd->value;
	w = goliveGetWorkAreaWidget(w);
	if (w)
		XmTextSetString( w, ( val ? val : ""));

	if (gd->value) {
		XtFree((void*) gd->value);
		gd->value = (char*)0;
	}
}
