#include <stdio.h>

#include "X11/Xatom.h"
#include "X11/Intrinsic.h"
#include "X11/Shell.h"

#include "Xm/Xm.h"

#include "live.h"

#define FALSE_T "false"
#define TRUE_T  "true"

int
xmtogglebutton_getter( GroupData_t * gd, void_f printfun)
{
	Widget w = gd->widget;
	int i    = XmToggleButtonGetState( w);
	char * val = (i ? TRUE_T : FALSE_T);

	(*printfun)( val);
	return 1;
}

void
xmtogglebutton_reader( GroupData_t * gd, char * toeol, string_f readfun)
{
	if (toeol)
		gd->value = XtNewString( toeol);
	else
		gd->value = (char*)0;
}


void
xmtogglebutton_setter( GroupData_t * gd)
{
	Widget w   = gd->widget;
	char * val = gd->value;
	int i = 0;

	if (val && (strcmp( val, TRUE_T) == 0))
		i = 1;
	XmToggleButtonSetState( w, (Boolean)i, False);

	if (gd->value) {
		XtFree((void*) gd->value);
		gd->value = (char*)0;
	}
}
