#ifndef _IST_H
#define _IST_H

typedef struct sattrib_s {
	char * s_name;
	char * s_value;
	struct sattrib_s * s_next;
} sattribute_t;

typedef struct sdata_s {
	int     len;
	void *  data;
} sdata_t;
typedef struct callbacklist_s {
	char *  attrname;
	int     type;
	int     (*callback)();
	void     *data;
	struct callbacklist_s * s_next;
} scallbacklist_t;

typedef struct stag_s {
	char * s_tag;
	scallbacklist_t * s_callbacks;
	struct stag_s * s_next;
} stag_t;

typedef struct snode_s {
	char         * s_tag;
	sattribute_t * s_attributes;
	int           numchildren;
	union {
		struct snode_s * children;
		sdata_t        * data;
	} body;
	struct snode_s * s_stackprev;
	struct snode_s * s_next;
	stag_t *         s_ref;
} DOCtree_t;

#define s_children      body.children
#define s_data          body.data

#define ON_ENTRY         (1<<1)
#define ON_EXIT          (1<<2)
#define ON_ATTR          (1<<3)
#define ON_DATA          (1<<4)

typedef struct sg_mime_s {
	char   * sg_mimetype;
	char   * sg_dtd;
	stag_t * sg_tags;
	struct   sg_mime_s * sg_next;
} SGML_t;

#ifndef _VOID_F
#define _VOID_F
typedef void (*void_f)();
#endif

#if !defined(_NO_PROTO) && !defined(__SGML)
#ifdef __cplusplus
extern "C" {
#endif

typedef int (*sgmlcb_f)(char*, char*, int, void*, void*);

extern SGML_t * scRegisterHTML(char*);
extern int scAddAttrCallback(SGML_t*,char*,char*, sgmlcb_f, void*);
extern int scProcessSGML(SGML_t*, InputStream*);

#ifdef __cplusplus
}
#endif
#endif
#endif
