/*
** A.J.Fountain,
** Imperial Software Technology (IST),
** Berkshire House,
** 252 Kings Road,
** Reading, 
** Berkshire,
** United Kingdom RG1 4HP.
**
** Telephone: +44 189 587055
** Fax:       +44 189 589005
** Email:     af@ist.co.uk
*/

/*
** sccsid = "@(#)ToolTip.h	1.4" -- 02/02/07
*/

#ifndef   _XmToolTip_h
#define   _XmToolTip_h

#include <X11/Intrinsic.h>
#include <Xm/Xm.h>
 
#ifdef    __cplusplus
extern "C" {
#endif /* __cplusplus */

#define XmTOOLTIP_VERSION         1
#define XmTOOLTIP_REVISION        1
#define XmTOOLTIP_UPDATE_LEVEL    1
#define XmToolTipVersion          ((XmTOOLTIP_VERSION * 1000) + XmTOOLTIP_REVISION)
#define XmTOOLTIP_VERSION_STRING  "@(#)ToolTip Version 1.1.1"

/*
** XmToolTip widget and class public pointers
*/

typedef struct _XmToolTipClassRec *XmToolTipWidgetClass ;
typedef struct _XmToolTipRec      *XmToolTipWidget ;

externalref WidgetClass            xmToolTipWidgetClass ;

/*
** Standard Sub-class definition
*/

#ifndef   XmIsToolTip
#define   XmIsToolTip(w)           XtIsSubclass(w, xmToolTipWidgetClass)
#endif /* XmIsToolTip */

/*
** Public Declarations
*/

#ifndef   _NO_PROTO
extern Widget XmCreateToolTip(Widget parent, String name, ArgList arglist, Cardinal argcount) ;
extern void   XmToolTipRegister(Widget tooltip, Widget target, XmString tip, XmFontList font) ;
extern void   XmToolTipUnregister(Widget tooltip, Widget target) ;
extern void   XmToolTipSetTip(Widget tooltip, Widget target, XmString tip, XmFontList font) ;
extern void   XmToolTipSetEnabled(Widget tooltip, Widget target, Boolean enabled) ;
#else  /* _NO_PROTO */
extern Widget XmCreateToolTip() ;
extern void   XmToolTipRegister() ;
extern void   XmToolTipUnregister() ;
extern void   XmToolTipSetTip() ;
extern void   XmToolTipSetEnabled() ;
#endif /* _NO_PROTO */

#ifdef    __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif /* __cplusplus */

/*
** New Resource Definitions
*/

#ifndef   XmNpopupDelay
#define   XmNpopupDelay                  "popupDelay"
#endif /* XmNpopupDelay */

#ifndef   XmNpopdownDelay
#define   XmNpopdownDelay                "popdownDelay"
#endif /* XmNpopdownDelay */

#ifndef   XmNverticalOffset
#define   XmNverticalOffset              "verticalOffset"
#endif /* XmNverticalOffset */

#ifndef   XmNhorizontalOffset
#define   XmNhorizontalOffset            "horizontalOffset"
#endif /* XmNhorizontalOffset */

#ifndef   XmNlabelWidget
#define   XmNlabelWidget                 "labelWidget"
#endif /* XmNlabelWidget */

#ifndef   XmCPopupDelay
#define   XmCPopupDelay                  "PopupDelay"
#endif /* XmCPopupDelay */

#ifndef   XmCPopdownDelay
#define   XmCPopdownDelay                "PopdownDelay"
#endif /* XmCPopdownDelay */

#ifndef   XmCVerticalOffset
#define   XmCVerticalOffset              "VerticalOffset"
#endif /* XmCVerticalOffset */

#ifndef   XmCHorizontalOffset
#define   XmCHorizontalOffset            "HorizontalOffset"
#endif /* XmCHorizontalOffset */

#ifndef   XmCLabelWidget
#define   XmCLabelWidget                 "LabelWidget"
#endif /* XmCLabelWidget */

/*
** ToolTip configuration by resources (Subpart Resourcing)
*/

#ifndef   XmNtooltip
#define   XmNtooltip                     "tooltip"
#endif /* XmNtooltip */

#ifndef   XmCTooltip
#define   XmCTooltip                     "Tooltip"
#endif /* XmCTooltip */

#ifndef   XmNtooltipFont
#define   XmNtooltipFont                 "tooltipFont"
#endif /* XmNtooltipFont */

#ifndef   XmCTooltipFont
#define   XmCTooltipFont                 "TooltipFont"
#endif /* XmCTooltipFont */

#ifndef   XmNtooltipRenderTable
#define   XmNtooltipRenderTable          "tooltipRenderTable"
#endif /* XmNtooltipRenderTable */

#ifndef   XmCTooltipRenderTable
#define   XmCTooltipRenderTable          "TooltipRenderTable"
#endif /* XmCTooltipRenderTable */

#endif /* _XmToolTip_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
