<?xml version='1.0' encoding='utf-8' ?><xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" indent="yes"/>
<xsl:template match="/">
<html>
<head>
<title>
XDesigner Generated Documentation
</title>
<link rel="stylesheet" href="xddoc.css" type="text/css"></link>
</head>
<body>
<xsl:apply-templates select="application"/>

<hr></hr>
</body>
<address>
(C) <a href="http://www.ist.co.uk/">Imperial Software Technology</a> 2001
</address>
</html>
</xsl:template>

<xsl:template match="application"><h2 class="sectionhead">XDesigner Application: 
<xsl:value-of select="@name"/>
</h2>
<xsl:apply-templates select="XDesigner"/>
<xsl:apply-templates select="directory"/>
<hr align="left" width="100%"></hr>
	<table>
	<tr>
		<th class="tablehead" colspan="2">File Manifest</th>
	</tr>
	<tr>
		<th class="tablehead">
		Type
		</th>
		<th class="tablehead">
		Filename
		</th>
	</tr>
	<xsl:apply-templates select="file"/>
	</table>
<hr align="left" width="100%"></hr>
<xsl:apply-templates select="interface"/>
</xsl:template>

<xsl:template match="XDesigner"><p class="miscinfo">
Export file format version: 
<xsl:value-of select="@version"/>
</p>
</xsl:template>

<xsl:template match="file"><tr>
<td>
<xsl:value-of select="@type"/>
</td>
<td>
<xsl:value-of select="@path"/>
</td>
</tr>
</xsl:template>

<xsl:template match="interface"><h2 class="sectionhead">
Widget Hierachy
</h2>
<xsl:apply-templates select="widget"/>

</xsl:template>

<xsl:template match="widget"><table>
	<tr>
	<td rowspan="20"><img width="25" src="spacer.gif"></img></td>	
	</tr>
	<tr>
	<td>
	<hr>
	</hr>
	</td>
	</tr>
	<tr>
	<th class="tablesubhead">Widget: 
		<em class="widgetname">

		<xsl:text disable-output-escaping="yes">&lt;a name=&quot;</xsl:text>
		<xsl:value-of select="@name"/>
		<xsl:text disable-output-escaping="yes">&quot;&gt;</xsl:text>

		<xsl:value-of select="@name"/>
	
		<xsl:text disable-output-escaping="yes">&lt;/a&gt;</xsl:text>
		</em>
		(
		<em class="widgettype">
		<xsl:value-of select="@type"/>
		</em>
		)
	</th>
	</tr>
	<tr>
	<td>
		<xsl:apply-templates select="code"/>
	</td>
	</tr>
	<tr>
	<td>
		<xsl:apply-templates select="resource"/>
	</td>
	</tr>
	<tr>
	<td>
		<xsl:apply-templates select="constraint"/>
	</td>
	</tr>
	<tr>
	<td>
		<xsl:apply-templates select="callback"/>
	</td>
	</tr>
	<tr>
	<td>
		<xsl:apply-templates select="method"/>
	</td>
	</tr>
	<tr>
	<td>
		<xsl:apply-templates select="event"/>
	</td>
	</tr>
	<tr>
	<td>
		<xsl:apply-templates select="widget"/>
	</td>
	</tr>
</table>
</xsl:template>

<xsl:template match="code"><xsl:if test="position()=1">
	<b class="tablesubhead">Widget Code</b>
</xsl:if>
	<ul class="codeul">
		<li class="listplain">Code Structure: <em class="widgettype"><xsl:value-of select="@codeStruct"/></em>
		</li>
		<li class="listplain">Storage Class: <em class="widgettype"><xsl:value-of select="@storageClass"/></em>
		</li>
		<li class="listplain">Access: <em class="widgettype"><xsl:value-of select="@accessControl"/></em>
		</li>
	</ul>
</xsl:template>

<xsl:template match="resource"><xsl:if test="position()=1">
<b class="tablesubhead">Widget Resources</b>
</xsl:if>
<li class="listplain">
Type: 
<em class="resourcetype">
<xsl:value-of select="@type"/></em>
Value: 
<em class="resourcevalue">
<xsl:value-of select="@value"/>
</em>
</li>
</xsl:template>

<xsl:template match="directory"><p class="miscinfo">
Directory path: 
<xsl:value-of select="@path"/>
</p>
</xsl:template>

<xsl:template match="constraint"><xsl:if test="position()=1">
<b class="tablesubhead">Widget Constraints</b>
</xsl:if>
<li class="listplain">
Type: 
<em class="resourcetype">
<xsl:value-of select="@type"/></em>
</li>
</xsl:template>

<xsl:template match="callback"><xsl:if test="position()=1">
<b class="tablesubhead">Widget Callbacks</b>
</xsl:if>
<li class="listplain">
Type: 
<em class="resourcetype">
<xsl:value-of select="@type"/></em>
Class: 
<em class="resourcevalue">
<xsl:value-of select="@class"/></em>
Procedure: 
<em class="callbackproc">
<xsl:value-of select="@procedure"/></em>
Client: 
<em class="callbackclient">
<xsl:value-of select="@client"/></em>

</li>
</xsl:template>

<xsl:template match="method"><xsl:if test="position()=1">
<b class="tablesubhead">Widget Methods</b>
</xsl:if>
<li class="listplain">
Type: 
<em class="resourcetype">
<xsl:value-of select="@type"/></em>
Class: 
<em class="resourcevalue">
<xsl:value-of select="@class"/></em>
Procedure: 
<em class="callbackproc">
<xsl:value-of select="@procedure"/></em>
</li>
</xsl:template>

<xsl:template match="event"><xsl:if test="position()=1">
<b class="tablesubhead">Widget Events</b>
</xsl:if>
<li class="listplain">
Procedure: 
<em class="callbackproc">
<xsl:value-of select="@procedure"/></em>
Raw: 
<em class="resourcevalue">
<xsl:value-of select="@raw"/></em>
Non-maskable: 
<em class="resourcetype">
<xsl:value-of select="@nonmaskable"/></em>
Client: 
<em class="callbackclient">
<xsl:value-of select="@client"/></em>
</li>
</xsl:template></xsl:stylesheet>
