#ifndef ISTIMAGE_H
#define ISTIMAGE_H

#define MAX_COL 256

#include <afxwin.h>
#include "ToolkitDefs.h"

class ISTImage
{
	public:
		sc_line     current_scline;
		int			numScanLines;
		int			currentLine;
		int 		numberOfColours;
		int			scanWidth;
		int			Width;
		int			Height;
		aByte R [MAX_COL];
		aByte G [MAX_COL];
		aByte B [MAX_COL];

	public:
		
		virtual sc_line getLine (int line) = 0;
		
		virtual sc_line nextLine() {
			currentLine++;
			return getLine(currentLine);
		}    
		
		virtual int getCurrentLine() {
			return currentLine;
		}

		virtual int getNumberOfLines() {
			return numScanLines;
		}
		
		virtual int getNumberOfColours() {
			return numberOfColours;
		}

		virtual Boolean hasMoreLines() {
			if (currentLine < numScanLines)
				return 1;
			return 0;
		}

		virtual void setWidth(int w){
			Width = w;
		};

		virtual void setHeight(int h){
			Height = h;
		};
		
		virtual int getWidth(){
			return Width;
		};

		virtual int getHeight(){
			return Height;
		};
		virtual aByte getRed (int i) = 0;

		virtual aByte getGreen (int i) = 0;

		virtual aByte getBlue (int i)= 0;

};

#endif

