#ifndef MFCIMAGE_H
#include "Image.h"

typedef union {
	char data [sizeof(RGBQUAD)];
	RGBQUAD quad;
} qconv;

#define MFCIMAGE_H
#define MAX_COL 256

class ColorIndex
{
	public:
		COLORREF *colorIndex;
		int numberOfColours;
	public:
		
		ColorIndex () {
			int i;
			numberOfColours = 0;
			colorIndex = (COLORREF *)0;
			colorIndex = new COLORREF[256];
			for (i=0; i<256; i++)
				colorIndex[i]=0x000000;
			
		}

		~ColorIndex() {
			free (colorIndex);
		}

		int handleColor (COLORREF c) {
			int i;
			for (i=0; i < numberOfColours; i++) {
				if (c == colorIndex[i])
					return i;
			} 
			
			colorIndex[numberOfColours] = c;
			numberOfColours++;
			return numberOfColours-1; //index
		}

		int getColours() {
			return numberOfColours;
		}
		BYTE getRed (int i) {
			return (BYTE) GetRValue(colorIndex[i]);
		}

		BYTE getGreen (int i) {
			return (BYTE) GetGValue(colorIndex[i]);
		}
		
		BYTE getBlue (int i) {
			return (BYTE) GetBValue(colorIndex[i]);
		}
};


class MFCImage : public ISTImage
{
	private:
		CBitmap		*theImage;
		ColorIndex	*colorHandler;
		BITMAP		imageInfo;
		DWORD		bitmapSize;
		void		*allBits;
		BYTE		*Pixel;
		int			bitsPerPixel;
		RGBQUAD		t;
		BITMAPINFO	bInfo;
		CDC *		draw;
		sc_line     scanLine;
		int			blue;
	
	public:
		COLORREF    currentColor;

	public:
		
		MFCImage (Graphics * g, GImage * image) {
			numberOfColours = 0;
			blue = 0;
			theImage = (CBitmap *) image;
			theImage->GetObject(sizeof(imageInfo),&imageInfo);
			scanLine  =  (BYTE*) malloc ((sizeof (int) * imageInfo.bmWidth));			
			colorHandler = new ColorIndex();	
			numScanLines    = imageInfo.bmHeight;
			scanWidth		= imageInfo.bmWidthBytes  ;
			Width = imageInfo.bmWidth;
			Height = imageInfo.bmHeight;
			draw = g->getGC();
		}

		~MFCImage () {
			//free (current_scline);
		}
		
		virtual sc_line getLine (int line) {
			int i;
			for (i=0; i< Width;i++) {
				scanLine[i] = (BYTE)colorHandler->handleColor(draw->GetPixel(i,line));	
			}
			
			return scanLine;
		}
			
		int getNumberOfColours() {
			return colorHandler->getColours();
		}

		aByte getRed(int i) {
			return (aByte) colorHandler->getRed(i);
		}
		aByte getGreen(int i) {
			return (aByte) colorHandler->getGreen(i);
		}
		aByte getBlue(int i) {
			return (aByte) colorHandler->getBlue(i);
		}
	
};

#endif


