#ifndef TOOLKITDEFS_H
#define TOOLKITDEFS_H

#include <stdio.h>
#include <stdlib.h>
#include <afxwin.h>
#ifdef WIN32
typedef CPoint  GPoint;
typedef CDC		Canvas;
typedef CBitmap GImage;
typedef int     PointSize;
typedef BOOL    Boolean;
typedef BYTE*	sc_line;
typedef BYTE	aByte;
#else
#include <X11/Intrinsic.h>
typedef XImage  GImage;
typedef XPoint  GPoint;
typedef short   PointSize;
typedef unsigned char*	sc_line;
typedef unsigned char aByte;
#endif

typedef void FontObj;
typedef void Color;

typedef enum {
	IGNORE_CURSOR, // for cursor-off
	WATCH_CURSOR,
	EXCHANGE_CURSOR,
	FLEUR_CURSOR,
	PENCIL_CURSOR,
	CROSS_CURSOR
} GCursor;

typedef enum {
	DIALOG_ERROR,
	DIALOG_INFORMATION,
	DIALOG_WARNING
} GDialogType;

typedef enum {
	COLOR_BLACK,
	COLOR_WHITE,
	COLOR_GRAY,
	COLOR_ORANGE
} GColor;

typedef enum {
	NOT_A_BUTTON,
	BUTTON_1,
	BUTTON_2,
	BUTTON_3,
	BUTTON_4,
	BUTTON_5
} GButton;
#endif
