#ifndef XMIMAGE_H
#define XMIMAGE_H

#define NUM_COLORS 255

#include "Image.h"
#include "Graphics.h"

class XGraphics;
class XMImage : public ISTImage
{
	private:
		XImage *theImage;
                Display * display;
		XColor  colors  [NUM_COLORS];
		unsigned char R [NUM_COLORS];
		unsigned char G [NUM_COLORS];
		unsigned char B [NUM_COLORS];
        int			CurrentLine;
		int			ncolors;
		Graphics *	myGraphics;
        sc_line     scanLine;
        Colormap	color_map;
	public:

		XMImage(Graphics * g, GImage * image) {
			
            Toolkit *tk       = Toolkit::getDefaultToolkit();
            int i = 0;
			display = (Display *) 0;
			display  = (Display *)tk->getDisplay();
			color_map=DefaultColormap(display,DefaultScreen(display));
			numScanLines      = 0;
			CurrentLine       = 0;
			numberOfColours   = 0;
			Width = g->getWidth();
            Height = g->getHeight();
			scanWidth		  = Width;
            scanLine  =  (BYTE*) malloc ((sizeof (int) * scanWidth));		
			theImage   = (XImage *) image;
            
			ncolors = 256; 

			for (i=0; i<ncolors; i++) {
				colors[i].pixel = (unsigned long) i;
				colors[i].pad   = 0;
			}
                        
            if (display != (Display *) 0)
                XQueryColors(display,color_map,colors,256);
            else
                printf("\nCannot Acquire Display...");
		}

		virtual sc_line getLine(int line) {
			int i;
			for (i=0; i<scanWidth; i++) 
				scanLine[i] = (unsigned char) XGetPixel(theImage, i, line );
			return scanLine;
		}
                int getNumberOfColours() {
			return 256;
		}

		BYTE getRed (int i) {
	        return (unsigned char) (colors[i].red  /256);
		}

		BYTE getGreen (int i) {
            return (unsigned char) (colors[i].green/256);
		}
		
		BYTE getBlue (int i) {
            return (unsigned char) (colors[i].blue /256);
		}

		void populateColours() {
			
		}
};

#endif


