/*
** X-Designer,
** Imperial Software Technology (IST),
** Berkshire House,
** 252 Kings Road,
** Reading, 
** Berkshire,
** United Kingdom RG1 4HP.
**
** Telephone: +44 189 587055
** Fax:       +44 189 589005
** Email:     support@ist.co.uk
*/

/*
** sccsid = "@(#)XdInt.h	1.2" -- 98/05/26
*/

#ifndef   _XD_INT_MAP_H
#define   _XD_INT_MAP_H

/*
** The following are bugs in 3.0 patched up
**
** Anything marked UNSUPPORTED is to allow compilation against EPak 2.5
** These resources are marked invisible in EPak30to25.xdc, and are missing
** from EPak25.xdc
**
** This file is #included LAST in EPak_config/code.c so they will already
** have a definition if loaded against 3.2 headers.
**
** Other resources not so marked are bugs - the widget supports them
** but the header does not define a definition. 
*/

/* 
** Implemented in the INT EditObject/ChartObject widgets but doesnt have a definition 
*/

#ifndef   XmNme
#define   XmNme                          "me"
#endif /* XmNme */

/*
** New in ObjectEditor 3.2
*/

#ifndef   XmRObjectClassList
#define   XmRObjectClassList             "UNSUPPORTED: XmRObjectClassList"
#endif /* XmRObjectClassList */

/*
** New in ObjecEditor and CellArray 3.2
*/

#ifndef   XmRPixmapList
#define   XmRPixmapList                  "UNSUPPORTED IN 3.1: XmRPixmapList"
#endif /* XmRPixmapList */

/*
** Implemented in the INT DataGroup object but doesnt have a definition
*/

#ifndef   XmNdataList
#define   XmNdataList                    "dataList"
#endif /* XmNdataList */

/*
** Implemented in the INT Chart object but doesnt have a definition except in the
** private header ChartBaseP.h
*/

#ifndef   XmNfreeze
#define   XmNfreeze                      "freeze"
#endif /* XmNfreeze */

#ifndef   XmNinternalDataList
#define   XmNinternalDataList            "internalDataList"
#endif /* XmNinternalDataList */

#ifndef   XmNseriesInfo
#define   XmNseriesInfo                  "seriesInfo"
#endif /* XmNseriesInfo */

/*
** Implemented in the INT Axis object but doesnt have a definition
*/

#ifndef   XmRTickPlacement
#define   XmRTickPlacement               "tickPlacement"
#endif /* XmRTickPlacement */

#ifndef   XmRAxisAnnotationPlacement
#define   XmRAxisAnnotationPlacement     "axisAnnotationPlacement"
#endif /* XmRAxisAnnotationPlacement */

/*
** New in Axis 3.1
*/

#ifndef   XmRAuxAnnotationList
#define   XmRAuxAnnotationList           "UNSUPPORTED: XmRAuxAnnotationList"
#endif /* XmRAuxAnnotationList */

#ifndef   XmRAuxPositionList
#define   XmRAuxPositionList             "UNSUPPORTED: XmRAuxPositionList"
#endif /* XmRAuxPositionList */

/*
** New in AxisObject 3.2
*/

#ifndef   XintANNOTATION_INSIDE
#define   XintANNOTATION_NONE             XintTICK_NONE
#define   XintANNOTATION_INSIDE           XintTICK_INSIDE
#define   XintANNOTATION_OUTSIDE          XintTICK_OUTSIDE
#define   XintANNOTATION_CROSS            XintTICK_CROSS
#endif /* XintANNOTATION_INSIDE */

/*
** New in ChartWidget 3.2
*/

#ifndef   XmRDynamicSymbolList
#define   XmRDynamicSymbolList            "UNSUPPORTED: XmRDynamicSymbolList"
#endif /* XmRDynamicSymbolList */

#ifndef   XintCHART_TYPE_BAR
#define   XintCHART_TYPE_BAR              0
#define   XintCHART_TYPE_PIE              1
#define   XintCHART_TYPE_BAR_LINE         2
#define   XintCHART_TYPE_SURFACE_3D       3
#define   XintCHART_TYPE_HIGH_LOW         4
#define   XintCHART_TYPE_HISTOGRAM        5
#define   XintCHART_TYPE_AREA             6
#define   XintCHART_TYPE_LINE             7
#define   XintCHART_TYPE_SCATTERED        8
#define   XintCHART_TYPE_BAR_3D           9
#define   XintCHART_TYPE_CELL_ARRAY      10
#define   XintCHART_TYPE_COMBINATION     11
#endif /* XintCHART_TYPE_BAR */

/*
** New in MultiPoint.h
*/

#ifndef   XintHANDLE_POINTS
#define   XintHANDLE_BOUNDS               1
#define   XintHANDLE_POINTS               2
#endif /* XintHANDLE_POINTS */

/*
** New in Symbols.h
*/

#ifndef   XintSYMBOL_X                      
#define   XintSYMBOL_X                    0
#define   XintSYMBOL_PLUS                 1
#define   XintSYMBOL_SQUARE               2
#define   XintSYMBOL_CIRCLE               3
#define   XintSYMBOL_TRIANGLE             4
#define   XintSYMBOL_DIAMOND              5
#define   XintSYMBOL_FILLED_SQUARE        6
#define   XintSYMBOL_FILLED_CIRCLE        7
#define   XintSYMBOL_FILLED_TRIANGLE      8
#define   XintSYMBOL_FILLED_DIAMOND       9
#define   XintSYMBOL_DATA                10
#define   XintSYMBOL_USER_DEFINED        11
#endif /* XintSYMBOL_X */

/*
** New in Polyline 3.2
*/

#ifndef   XmRDynamicPointArray
#define   XmRDynamicPointArray           "UNSUPPORTED: XmRDynamicPointArray"
#endif /* XmRDynamicPointArray */

/*
** Implemented i Xint/HighLowS.h, but guarded by #ifndef XmNtickLength         
** Which is defined in Oval/Wedge.h files, so this can be compiled out in error 
*/

#ifndef   XmNdrawCandlestick
#define   XmNdrawCandlestick             "drawCandlestick"
#endif /* XmNdrawCandlestick */

/*
** New in ChartBase.h 3.2
*/

#ifndef   XmRChartType
#define   XmRChartType                   "UNSUPPORTED: XmRChartType"
#endif /* XmRChartType */

/*
** New in MultiPoint.h 3.2
*/

#ifndef   XmRHandleMode
#define   XmRHandleMode                  "UNSUPPORTED: XmRHandleMode"
#endif /* XmRHandleMode */

#ifndef   XmRSymbolType
#define   XmRSymbolType                  "UNSUPPORTED: XmRSymbolType"
#endif /* XmRSymbolType */

/*
** New in Symbol.h 3.2
*/

#ifndef   XmRLabelGravity
#define   XmRLabelGravity                "UNSUPPORTED: XmRLabelGravity"
#endif /* XmRLabelGravity */

/*
** New in Text.h 3.2
*/

#ifndef   XmRTextAlignment
#define   XmRTextAlignment               "UNSUPPORTED: XmRTextAlignment"
#endif /* XmRTextAlignment */

#ifndef   XmRTextAnchor
#define   XmRTextAnchor                  "UNSUPPORTED: XmRTextAnchor"
#endif /* XmRTextAnchor */

/*
** New in Text.h 3.2
*/

#ifndef   XmRTextAlignment
#define   XmRTextAlignment               "UNSUPPORTED: XmRTextAlignment"
#endif /* XmRTextAlignment */

/*
** Mapping 3.0 onto 2.5 we need to remap the following Resources and Types
**
** NB: All these resources are marked invisible in xdconfig
*/

#ifndef   XmNxLabelLimits
#define   XmNxLabelLimits                "UNSUPPORTED: XmNxLabelLimits"
#endif /* XmNxLabelLimits */

#ifndef   XmNyLabelLimits
#define   XmNyLabelLimits                "UNSUPPORTED: XmNyLabelLimits"
#endif /* XmNyLabelLimits */

#ifndef   XmNzLabelLimits
#define   XmNzLabelLimits                "UNSUPPORTED: XmNzLabelLimits"
#endif /* XmNzLabelLimits */

#endif /* _XD_INT_MAP_H */
