/*
** X-Designer,
** Imperial Software Technology (IST),
** Kings Court,
** 185 Kings Road,
** Reading, 
** Berkshire,
** United Kingdom RG1 4EX.
**
** Telephone: +44 189 587055
** Fax:       +44 189 589005
** Email:     support@ist.co.uk
** Web:       http://www.ist.co.uk
*/

/*
** sccsid[] = {"@(#)XdXrtMap.h	1.22"} -- 03/05/22
*/

#ifndef   _XRT_XDESIGNER_MAP_H
#define   _XRT_XDESIGNER_MAP_H

#ifdef    HASXRTGRAPH
#include <Xm/XrtGraph.h>
#endif /* HASXRTGRAPH */

#ifdef    HASXRT3D
#include <Xm/Xrt3d.h>
#endif /* HASXRT3D */

#ifdef    HASXRTTABLE
#include <Xm/XrtTable.h>
#include <Xm/XrtLabel.h>
#endif /* HASXRTTABLE */

#ifdef    HASXRTFIELD
#include <Xm/XrtField.h>
#endif /* HASXRTFIELD */

#ifdef    HASXRTGEAR
#include <Xm/XrtGearAll.h>
#endif /* HASXRTGEAR */

#ifdef    HASXRTGAUGE
#include <Xm/XrtGaugeAll.h>
#endif /* HASXRTGAUGE */

/* The following resources are private and should not appear on any resource panel */
/* However, they do appear in the widget resource table, so need some definitions  */
/* to enable XDconfig to hide them.                                                */

#ifndef   XmNxrtGearKey
#define   XmNxrtGearKey             "xrtGearKey"
#endif /* XmNxrtGearKey */

#ifndef   XmNxrtGearLock
#define   XmNxrtGearLock            "xrtGearLock"
#endif /* XmNxrtGearLock */

#ifndef   XmNxrtTblKey
#define   XmNxrtTblKey              "xrtTblKey"
#endif /* XmNxrtTblKey */

#ifndef   XmNxrtTblLock
#define   XmNxrtTblLock             "xrtTblLock"
#endif /* XmNxrtTblLock */

#ifndef   XmNxrtFldKey
#define   XmNxrtFldKey              "xrtFldKey"
#endif /* XmNxrtFldKey */

#ifndef   XmNxrtFldLock
#define   XmNxrtFldLock             "xrtFldLock"
#endif /* XmNxrtFldLock */

#ifndef   XmNxrtGearInitialized
#define   XmNxrtGearInitialized     "xrtGearInitialized"
#endif /* XmNxrtGearInitialized */

/*
** Synthetic: Outliner has private resource Initialized, not xrtGearInitiialized
*/

#ifndef   XmNxrtGearOutlinerInitialized
#define   XmNxrtGearOutlinerInitialized     "Initialized"
#endif /* XmNxrtGearOutlinerInitialized */

/*
** BACKWARDS COMPATABILITY
*/

/*
** XrtGear: Added in Volume 10
*/

#if       XRTGEAR_RELEASE < 2000

#ifndef   XmNxrtGearBarColor
#define   XmNxrtGearBarColor                    "xrtGearBarColor"
#endif /* XmNxrtGearBarColor */

#ifndef   XmNxrtGearBarCount
#define   XmNxrtGearBarCount                    "xrtGearBarCount"
#endif /* XmNxrtGearBarCount */

#ifndef   XmNxrtGearBarSpacing
#define   XmNxrtGearBarSpacing                  "xrtGearBarSpacing"
#endif /* XmNxrtGearBarSpacing */

#ifndef   XmNxrtGearDoubleBuffer
#define   XmNxrtGearDoubleBuffer                "xrtGearDoubleBuffer"
#endif /* XmNxrtGearDoubleBuffer */

#ifndef   XmNxrtGearIcon
#define   XmNxrtGearIcon                        "xrtGearIcon"
#endif /* XmNxrtGearIcon */

#ifndef   XmNxrtGearLabel
#define   XmNxrtGearLabel                       "xrtGearLabel"
#endif /* XmNxrtGearLabel */

#ifndef   XmNxrtGearLabelAlignment
#define   XmNxrtGearLabelAlignment              "xrtGearLabelAlignment"
#endif /* XmNxrtGearLabelAlignment */

#ifndef   XmNxrtGearLabelFormat
#define   XmNxrtGearLabelFormat                 "xrtGearLabelFormat"
#endif /* XmNxrtGearLabelFormat */

#ifndef   XmNxrtGearLabelFormatCallback
#define   XmNxrtGearLabelFormatCallback         "xrtGearLabelFormatCallback"
#endif /* XmNxrtGearLabelFormatCallback */

#ifndef   XmNxrtGearLabelShow
#define   XmNxrtGearLabelShow                   "xrtGearLabelShow"
#endif /* XmNxrtGearLabelShow */

#ifndef   XmNxrtGearProgressCallback
#define   XmNxrtGearProgressCallback            "xrtGearProgressCallback"
#endif /* XmNxrtGearProgressCallback */

#ifndef   XmNxrtGearProgressTimeOut
#define   XmNxrtGearProgressTimeOut             "xrtGearProgressTimeOut"
#endif /* XmNxrtGearProgressTimeOut */

#ifndef   XmNxrtGearProgressType
#define   XmNxrtGearProgressType                "xrtGearProgressType"
#endif /* XmNxrtGearProgressType */

#ifndef   XmNxrtGearValuePercent
#define   XmNxrtGearValuePercent                "xrtGearValuePercent"
#endif /* XmNxrtGearValuePercent */

#ifndef   XmNxrtGearBackgroundSelected
#define   XmNxrtGearBackgroundSelected          "xrtGearBackgroundSelected"
#endif /* XmNxrtGearBackgroundSelected */

#ifndef   XmNxrtGearFontListSelected
#define   XmNxrtGearFontListSelected            "xrtGearFontListSelected"
#endif /* XmNxrtGearFontListSelected */

#ifndef   XmNxrtGearForegroundSelected
#define   XmNxrtGearForegroundSelected          "xrtGearForegroundSelected"
#endif /* XmNxrtGearForegroundSelected */

#ifndef   XmNxrtGearIconClosed
#define   XmNxrtGearIconClosed                  "xrtGearIconClosed"
#endif /* XmNxrtGearIconClosed */

#ifndef   XmNxrtGearIconClosedSelected
#define   XmNxrtGearIconClosedSelected          "xrtGearIconClosedSelected"
#endif /* XmNxrtGearIconClosedSelected */

#ifndef   XmNxrtGearIconItem
#define   XmNxrtGearIconItem                    "xrtGearIconItem"
#endif /* XmNxrtGearIconItem */

#ifndef   XmNxrtGearIconItemSelected
#define   XmNxrtGearIconItemSelected            "xrtGearIconItemSelected"
#endif /* XmNxrtGearIconItemSelected */

#ifndef   XmNxrtGearIconOpen
#define   XmNxrtGearIconOpen                    "xrtGearIconOpen"
#endif /* XmNxrtGearIconOpen */

#ifndef   XmNxrtGearIconOpenSelected
#define   XmNxrtGearIconOpenSelected            "xrtGearIconOpenSelected"
#endif /* XmNxrtGearIconOpenSelected */

#ifndef   XmNxrtGearLineColor
#define   XmNxrtGearLineColor                   "xrtGearLineColor"
#endif /* XmNxrtGearLineColor */

#ifndef   XmNxrtGearLineStyle
#define   XmNxrtGearLineStyle                   "xrtGearLineStyle"
#endif /* XmNxrtGearLineStyle */

#ifndef   XmNxrtGearLineWidth
#define   XmNxrtGearLineWidth                   "xrtGearLineWidth"
#endif /* XmNxrtGearLineWidth */

#ifndef   XmNxrtGearShortcutShow
#define   XmNxrtGearShortcutShow                "xrtGearShortcutShow"
#endif /* XmNxrtGearShortcutShow */

#ifndef   XmNxrtGearShortcutSize
#define   XmNxrtGearShortcutSize                "xrtGearShortcutSize"
#endif /* XmNxrtGearShortcutSize */

#ifndef   XmNxrtGearMarginLeft
#define   XmNxrtGearMarginLeft                  "xrtGearMarginLeft"
#endif /* XmNxrtGearMarginLeft */

#ifndef   XmNxrtGearMarginRight
#define   XmNxrtGearMarginRight                 "xrtGearMarginRight"
#endif /* XmNxrtGearMarginRight */

#ifndef   XmNxrtGearNodeAlignment
#define   XmNxrtGearNodeAlignment               "xrtGearNodeAlignment"
#endif /* XmNxrtGearNodeAlignment */

#ifndef   XmNxrtGearSelected
#define   XmNxrtGearSelected                    "xrtGearSelected"
#endif /* XmNxrtGearSelected */

#ifndef   XmNxrtGearWidthMaximum
#define   XmNxrtGearWidthMaximum                "xrtGearWidthMaximum"
#endif /* XmNxrtGearWidthMaximum */

#ifndef   XmNxrtGearWidthMinimum
#define   XmNxrtGearWidthMinimum                "xrtGearWidthMinimum"
#endif /* XmNxrtGearWidthMinimum */

#ifndef   XmNxrtGearWidthPreferredCount
#define   XmNxrtGearWidthPreferredCount         "xrtGearWidthPreferredCount"
#endif /* XmNxrtGearWidthPreferredCount */

#ifndef   XmNxrtGearWidthResizePolicy
#define   XmNxrtGearWidthResizePolicy           "xrtGearWidthResizePolicy"
#endif /* XmNxrtGearWidthResizePolicy */

#ifndef   XmNxrtGearWidthSizingPolicy
#define   XmNxrtGearWidthSizingPolicy           "xrtGearWidthSizingPolicy"
#endif /* XmNxrtGearWidthSizingPolicy */

#ifndef   XmNxrtGearArrowDisplayPolicy
#define   XmNxrtGearArrowDisplayPolicy          "xrtGearArrowDisplayPolicy"
#endif /* XmNxrtGearArrowDisplayPolicy */

#ifndef   XmNxrtGearArrowHeight
#define   XmNxrtGearArrowHeight                 "xrtGearArrowHeight"
#endif /* XmNxrtGearArrowHeight */

#ifndef   XmNxrtGearArrowWidth
#define   XmNxrtGearArrowWidth                  "xrtGearArrowWidth"
#endif /* XmNxrtGearArrowWidth */

#ifndef   XmNxrtGearPageAttachPolicy
#define   XmNxrtGearPageAttachPolicy            "xrtGearPageAttachPolicy"
#endif /* XmNxrtGearPageAttachPolicy */

#ifndef   XmNxrtGearActivateCallback
#define   XmNxrtGearActivateCallback            "xrtGearActivateCallback"
#endif /* XmNxrtGearActivateCallback */

#ifndef   XmNxrtGearAutoSort
#define   XmNxrtGearAutoSort                    "xrtGearAutoSort"
#endif /* XmNxrtGearAutoSort */

#ifndef   XmNxrtGearBorderLocation
#define   XmNxrtGearBorderLocation              "xrtGearBorderLocation"
#endif /* XmNxrtGearBorderLocation */

#ifndef   XmNxrtGearColumnLabelsShow
#define   XmNxrtGearColumnLabelsShow            "xrtGearColumnLabelsShow"
#endif /* XmNxrtGearColumnLabelsShow */

#ifndef   XmNxrtGearColumnList
#define   XmNxrtGearColumnList                  "xrtGearColumnList"
#endif /* XmNxrtGearColumnList */

#ifndef   XmNxrtGearColumnMoveAllow
#define   XmNxrtGearColumnMoveAllow             "xrtGearColumnMoveAllow"
#endif /* XmNxrtGearColumnMoveAllow */

#ifndef   XmNxrtGearColumnMoveCallback
#define   XmNxrtGearColumnMoveCallback          "xrtGearColumnMoveCallback"
#endif /* XmNxrtGearColumnMoveCallback */

#ifndef   XmNxrtGearColumnOrderList
#define   XmNxrtGearColumnOrderList             "xrtGearColumnOrderList"
#endif /* XmNxrtGearColumnOrderList */

#ifndef   XmNxrtGearColumnSelected
#define   XmNxrtGearColumnSelected              "xrtGearColumnSelected"
#endif /* XmNxrtGearColumnSelected */

#ifndef   XmNxrtGearColumnSelectionCallback
#define   XmNxrtGearColumnSelectionCallback     "xrtGearColumnSelectionCallback"
#endif /* XmNxrtGearColumnSelectionCallback */

#ifndef   XmNxrtGearCursor
#define   XmNxrtGearCursor                      "xrtGearCursor"
#endif /* XmNxrtGearCursor */

#ifndef   XmNxrtGearCursorResizeWidth
#define   XmNxrtGearCursorResizeWidth           "xrtGearCursorResizeWidth"
#endif /* XmNxrtGearCursorResizeWidth */

#ifndef   XmNxrtGearCursorTracking
#define   XmNxrtGearCursorTracking              "xrtGearCursorTracking"
#endif /* XmNxrtGearCursorTracking */

#ifndef   XmNxrtGearCursorTrackingCallback
#define   XmNxrtGearCursorTrackingCallback      "xrtGearCursorTrackingCallback"
#endif /* XmNxrtGearCursorTrackingCallback */

#ifndef   XmNxrtGearFolderStateCallback
#define   XmNxrtGearFolderStateCallback         "xrtGearFolderStateCallback"
#endif /* XmNxrtGearFolderStateCallback */

#ifndef   XmNxrtGearFolderStateMask
#define   XmNxrtGearFolderStateMask             "xrtGearFolderStateMask"
#endif /* XmNxrtGearFolderStateMask */

#ifndef   XmNxrtGearHeightPreferredCount
#define   XmNxrtGearHeightPreferredCount        "xrtGearHeightPreferredCount"
#endif /* XmNxrtGearHeightPreferredCount */

#ifndef   XmNxrtGearHeightResizePolicy
#define   XmNxrtGearHeightResizePolicy          "xrtGearHeightResizePolicy"
#endif /* XmNxrtGearHeightResizePolicy */

#ifndef   XmNxrtGearHeightSizingPolicy
#define   XmNxrtGearHeightSizingPolicy          "xrtGearHeightSizingPolicy"
#endif /* XmNxrtGearHeightSizingPolicy */

#ifndef   XmNxrtGearHeightVirtual
#define   XmNxrtGearHeightVirtual               "xrtGearHeightVirtual"
#endif /* XmNxrtGearHeightVirtual */

#ifndef   XmNxrtGearImportCallback
#define   XmNxrtGearImportCallback              "xrtGearImportCallback"
#endif /* XmNxrtGearImportCallback */

#ifndef   XmNxrtGearNodeChildList
#define   XmNxrtGearNodeChildList               "xrtGearNodeChildList"
#endif /* XmNxrtGearNodeChildList */

#ifndef   XmNxrtGearNodeCompareProc
#define   XmNxrtGearNodeCompareProc             "xrtGearNodeCompareProc"
#endif /* XmNxrtGearNodeCompareProc */

#ifndef   XmNxrtGearNodeCreateCallback
#define   XmNxrtGearNodeCreateCallback          "xrtGearNodeCreateCallback"
#endif /* XmNxrtGearNodeCreateCallback */

#ifndef   XmNxrtGearNodeCurrent
#define   XmNxrtGearNodeCurrent                 "xrtGearNodeCurrent"
#endif /* XmNxrtGearNodeCurrent */

#ifndef   XmNxrtGearNodeCurrentChangedCallback
#define   XmNxrtGearNodeCurrentChangedCallback  "xrtGearNodeCurrentChangedCallback"
#endif /* XmNxrtGearNodeCurrentChangedCallback */

#ifndef   XmNxrtGearNodeHeight
#define   XmNxrtGearNodeHeight                  "xrtGearNodeHeight"
#endif /* XmNxrtGearNodeHeight */

#ifndef   XmNxrtGearNodeImportPolicy
#define   XmNxrtGearNodeImportPolicy            "xrtGearNodeImportPolicy"
#endif /* XmNxrtGearNodeImportPolicy */

#ifndef   XmNxrtGearNodeIndent
#define   XmNxrtGearNodeIndent                  "xrtGearNodeIndent"
#endif /* XmNxrtGearNodeIndent */

#ifndef   XmNxrtGearNodeMoveCallback
#define   XmNxrtGearNodeMoveCallback            "xrtGearNodeMoveCallback"
#endif /* XmNxrtGearNodeMoveCallback */

#ifndef   XmNxrtGearNodeMovePolicy
#define   XmNxrtGearNodeMovePolicy              "xrtGearNodeMovePolicy"
#endif /* XmNxrtGearNodeMovePolicy */

#ifndef   XmNxrtGearNodeSpacing
#define   XmNxrtGearNodeSpacing                 "xrtGearNodeSpacing"
#endif /* XmNxrtGearNodeSpacing */

#ifndef   XmNxrtGearNodeStyleDefault
#define   XmNxrtGearNodeStyleDefault            "xrtGearNodeStyleDefault"
#endif /* XmNxrtGearNodeStyleDefault */

#ifndef   XmNxrtGearNodeStyleList
#define   XmNxrtGearNodeStyleList               "xrtGearNodeStyleList"
#endif /* XmNxrtGearNodeStyleList */

#ifndef   XmNxrtGearNodeTop
#define   XmNxrtGearNodeTop                     "xrtGearNodeTop"
#endif /* XmNxrtGearNodeTop */

#ifndef   XmNxrtGearNodeVisibleList
#define   XmNxrtGearNodeVisibleList             "xrtGearNodeVisibleList"
#endif /* XmNxrtGearNodeVisibleList */

#ifndef   XmNxrtGearPSFontMapList
#define   XmNxrtGearPSFontMapList               "xrtGearPSFontMapList"
#endif /* XmNxrtGearPSFontMapList */

#ifndef   XmNxrtGearPrintCallback
#define   XmNxrtGearPrintCallback               "xrtGearPrintCallback"
#endif /* XmNxrtGearPrintCallback */

#ifndef   XmNxrtGearRepaint
#define   XmNxrtGearRepaint                     "xrtGearRepaint"
#endif /* XmNxrtGearRepaint */

#ifndef   XmNxrtGearScrollBarHoriz
#define   XmNxrtGearScrollBarHoriz              "xrtGearScrollBarHoriz"
#endif /* XmNxrtGearScrollBarHoriz */

#ifndef   XmNxrtGearScrollBarHorizDisplayPolicy
#define   XmNxrtGearScrollBarHorizDisplayPolicy "xrtGearScrollBarHorizDisplayPolicy"
#endif /* XmNxrtGearScrollBarHorizDisplayPolicy */

#ifndef   XmNxrtGearScrollBarVert
#define   XmNxrtGearScrollBarVert               "xrtGearScrollBarVert"
#endif /* XmNxrtGearScrollBarVert */

#ifndef   XmNxrtGearScrollBarVertDisplayPolicy
#define   XmNxrtGearScrollBarVertDisplayPolicy  "xrtGearScrollBarVertDisplayPolicy"
#endif /* XmNxrtGearScrollBarVertDisplayPolicy */

#ifndef   XmNxrtGearSelectedNodeList
#define   XmNxrtGearSelectedNodeList            "xrtGearSelectedNodeList"
#endif /* XmNxrtGearSelectedNodeList */

#ifndef   XmNxrtGearSelectionCallback
#define   XmNxrtGearSelectionCallback           "xrtGearSelectionCallback"
#endif /* XmNxrtGearSelectionCallback */

#ifndef   XmNxrtGearSelectionPolicy
#define   XmNxrtGearSelectionPolicy             "xrtGearSelectionPolicy"
#endif /* XmNxrtGearSelectionPolicy */

#ifndef   XmNxrtGearSelectionRestrictions
#define   XmNxrtGearSelectionRestrictions       "xrtGearSelectionRestrictions"
#endif /* XmNxrtGearSelectionRestrictions */

#ifndef   XmNxrtGearTextHorizClipPolicy
#define   XmNxrtGearTextHorizClipPolicy         "xrtGearTextHorizClipPolicy"
#endif /* XmNxrtGearTextHorizClipPolicy */

#ifndef   XmNxrtGearTreeData
#define   XmNxrtGearTreeData                    "xrtGearTreeData"
#endif /* XmNxrtGearTreeData */

#ifndef   XmNxrtGearWidthChar
#define   XmNxrtGearWidthChar                   "xrtGearWidthChar"
#endif /* XmNxrtGearWidthChar */

#ifndef   XmNxrtGearWidthVirtual
#define   XmNxrtGearWidthVirtual                "xrtGearWidthVirtual"
#endif /* XmNxrtGearWidthVirtual */

#ifndef   XmNxrtGearArrow
#define   XmNxrtGearArrow                       "xrtGearArrow"
#endif /* XmNxrtGearArrow */

#ifndef   XmNxrtGearArrowClass
#define   XmNxrtGearArrowClass                  "xrtGearArrowClass"
#endif /* XmNxrtGearArrowClass */

#ifndef   XmNxrtGearArrowType
#define   XmNxrtGearArrowType                   "xrtGearArrowType"
#endif /* XmNxrtGearArrowType */

#ifndef   XmNxrtGearMenuCallback
#define   XmNxrtGearMenuCallback                "xrtGearMenuCallback"
#endif /* XmNxrtGearMenuCallback */

#ifndef   XmNxrtGearMenuList
#define   XmNxrtGearMenuList                    "xrtGearMenuList"
#endif /* XmNxrtGearMenuList */

#ifndef   XmNxrtGearPickList
#define   XmNxrtGearPickList                    "xrtGearPickList"
#endif /* XmNxrtGearPickList */

#ifndef   XmNxrtGearPickListIndex
#define   XmNxrtGearPickListIndex               "xrtGearPickListIndex"
#endif /* XmNxrtGearPickListIndex */

#ifndef   XmNxrtGearSearchPolicy
#define   XmNxrtGearSearchPolicy                "xrtGearSearchPolicy"
#endif /* XmNxrtGearSearchPolicy */

#ifndef   XmNxrtGearSpacing
#define   XmNxrtGearSpacing                     "xrtGearSpacing"
#endif /* XmNxrtGearSpacing */

#ifndef   XmNxrtGearTextField
#define   XmNxrtGearTextField                   "xrtGearTextField"
#endif /* XmNxrtGearTextField */

#ifndef   XRTGEAR_ALIGN_CENTER
#define   XRTGEAR_ALIGN_BEGINNING               0
#define   XRTGEAR_ALIGN_CENTER                  1
#define   XRTGEAR_ALIGN_END                     2
#endif /* XRTGEAR_ALIGN_CENTER */

#ifndef   XRTGEAR_ARROW_WEDGE
#define   XRTGEAR_ARROW_NONE                    0
#define   XRTGEAR_ARROW_WEDGE                   1
#define   XRTGEAR_ARROW_WITH_UNDERBAR           2
#define   XRTGEAR_ARROW_CUSTOM                  3
#endif /* XRTGEAR_ARROW_WEDGE */

#ifndef   XRTGEAR_BORDER_LOC_EACH_LABEL_SEPARATED_FROM_NODES
#define   XRTGEAR_BORDER_LOC_LABELS                              0
#define   XRTGEAR_BORDER_LOC_NODES                               1
#define   XRTGEAR_BORDER_LOC_LABELS_SEPARATED_FROM_NODES         2
#define   XRTGEAR_BORDER_LOC_EACH_LABEL_SEPARATED_FROM_NODES     3
#define   XRTGEAR_BORDER_LOC_EACH_LABEL                          4
#define   XRTGEAR_BORDER_LOC_LABELS_AND_NODES                    5
#endif /* XRTGEAR_BORDER_LOC_EACH_LABEL_SEPARATED_FROM_NODES */

#ifndef   XRTGEAR_COLUMN_RESIZE_ALL
#define   XRTGEAR_COLUMN_RESIZE_ALL            0
#define   XRTGEAR_COLUMN_RESIZE_LABELS_ONLY    1
#define   XRTGEAR_COLUMN_RESIZE_NONE           2
#endif /* XRTGEAR_COLUMN_RESIZE_ALL */

#ifndef   XRTGEAR_DISPLAY_AS_NEEDED
#define   XRTGEAR_DISPLAY_AS_NEEDED            0
#define   XRTGEAR_DISPLAY_ALWAYS               1
#define   XRTGEAR_DISPLAY_NEVER                2
#endif /* XRTGEAR_DISPLAY_AS_NEEDED */

#ifndef   XRTGEAR_FOLDERSTATE_INVALID 
#define   XRTGEAR_FOLDERSTATE_INVALID              0
#define   XRTGEAR_FOLDERSTATE_CLOSED         (1 << 0)
#define   XRTGEAR_FOLDERSTATE_OPEN_FOLDERS   (1 << 1)
#define   XRTGEAR_FOLDERSTATE_OPEN_ITEMS     (1 << 2)
#define   XRTGEAR_FOLDERSTATE_OPEN_ALL       (1 << 3)
#endif /* XRTGEAR_FOLDERSTATE_INVALID */

#ifndef   XRTGEAR_IMPORT_NOTHING
#define   XRTGEAR_IMPORT_NOTHING               0
#define   XRTGEAR_IMPORT_ANYTHING              1
#define   XRTGEAR_IMPORT_WITHIN_APP            2
#define   XRTGEAR_IMPORT_WITHIN_WIDGET         3
#endif /* XRTGEAR_IMPORT_NOTHING */

#ifndef   XRTGEAR_LINESTYLE_NONE
#define   XRTGEAR_LINESTYLE_NONE               0
#define   XRTGEAR_LINESTYLE_DOTTED             1
#define   XRTGEAR_LINESTYLE_SOLID              2
#endif /* XRTGEAR_LINESTYLE_NONE */

#ifndef   XRTGEAR_MENU_ALIGN_BOTH
#define   XRTGEAR_MENU_ALIGN_BEGINNING         0
#define   XRTGEAR_MENU_ALIGN_BOTH              1
#define   XRTGEAR_MENU_ALIGN_END               2
#endif /* XRTGEAR_MENU_ALIGN_BOTH */

#ifndef   XRTGEAR_MOVE_NOWHERE
#define   XRTGEAR_MOVE_NOWHERE                 0
#define   XRTGEAR_MOVE_WITHIN_LEVEL            1
#define   XRTGEAR_MOVE_WITHIN_WIDGET           2
#define   XRTGEAR_MOVE_WITHIN_APP              3
#endif /* XRTGEAR_MOVE_NOWHERE */

#ifndef   XRTGEAR_ATTACH_ALWAYS
#define   XRTGEAR_ATTACH_ALWAYS                0
#define   XRTGEAR_ATTACH_NONE                  1
#endif /* XRTGEAR_ATTACH_ALWAYS */

#ifndef   XRTGEAR_PROGRESS_BAR
#define   XRTGEAR_PROGRESS_BAR                 0
#define   XRTGEAR_PROGRESS_DISCRETE_BAR        1
#define   XRTGEAR_PROGRESS_ICON                2
#define   XRTGEAR_PROGRESS_STACKING_ICONS      3
#endif /* XRTGEAR_PROGRESS_BAR */

#ifndef   XRTGEAR_SEARCH_SINGLE
#define   XRTGEAR_SEARCH_SINGLE                0
#define   XRTGEAR_SEARCH_MULTICHAR             0
#endif /* XRTGEAR_SEARCH_SINGLE */

#ifndef   XRTGEAR_SELECTION_POLICY_SINGLE
#define   XRTGEAR_SELECTION_POLICY_NONE                     0
#define   XRTGEAR_SELECTION_POLICY_SINGLE                   1
#define   XRTGEAR_SELECTION_POLICY_SINGLE_AUTO_SELECT       2
#define   XRTGEAR_SELECTION_POLICY_RANGE                    3
#define   XRTGEAR_SELECTION_POLICY_MULTIPLE                 4
#define   XRTGEAR_SELECTION_POLICY_MULTIPLE_AUTO_UNSELECT   5
#endif /* XRTGEAR_SELECTION_POLICY_SINGLE */

#ifndef   XRTGEAR_RESTRICT_NOTHING
#define   XRTGEAR_RESTRICT_NOTHING             0
#define   XRTGEAR_RESTRICT_ITEMS               (1<<0)
#define   XRTGEAR_RESTRICT_FOLDERS             (1<<1)
#define   XRTGEAR_RESTRICT_MULTI_LEVEL         (1<<2)
#define   XRTGEAR_RESTRICT_ALL                 \
	XRTGEAR_RESTRICT_ITEMS | XRTGEAR_RESTRICT_FOLDERS | XRTGEAR_RESTRICT_MULTI_LEVEL
#endif /* XRTGEAR_RESTRICT_NOTHING */

#ifndef   XRTGEAR_SIZE_CHAR
#define   XRTGEAR_SIZE_PIXEL                   0
#define   XRTGEAR_SIZE_CHAR                    1
#define   XRTGEAR_SIZE_NODE                    2
#define   XRTGEAR_SIZE_COLUMN                  3
#define   XRTGEAR_SIZE_LABEL_VARIABLE          4
#define   XRTGEAR_SIZE_VARIABLE                5
#endif /* XRTGEAR_SIZE_CHAR */

#ifndef   XRTGEAR_TRUNCATE_WITH_ARROW
#define   XRTGEAR_TRUNCATE                     0
#define   XRTGEAR_TRUNCATE_WITH_ARROW          1
#define   XRTGEAR_COMPRESS_WITH_ELLIPSIS       2
#endif /* XRTGEAR_TRUNCATE_WITH_ARROW */

#ifndef   XRTGEAR_WIDGET_RESIZE_VARIABLE
#define   XRTGEAR_WIDGET_RESIZE_VARIABLE       0
#define   XRTGEAR_WIDGET_RESIZE_GROW_ONLY      1
#define   XRTGEAR_WIDGET_RESIZE_FIXED          2
#endif /* XRTGEAR_WIDGET_RESIZE_VARIABLE */

#ifndef   XmRXrtGearAlignerAlignment
#define   XmRXrtGearAlignerAlignment           "XrtGearAlignerAlignment"
#endif /* XmRXrtGearAlignerAlignment */

#ifndef   XmRXrtGearAlignment
#define   XmRXrtGearAlignment                  "XrtGearAlignment"
#endif /* XmRXrtGearAlignment */

#ifndef   XmRXrtGearAnchorSide
#define   XmRXrtGearAnchorSide                 "XrtGearAnchorSide"
#endif /* XmRXrtGearAnchorSide */

#ifndef   XmRXrtGearArrowType
#define   XmRXrtGearArrowType                  "XrtGearArrowType"
#endif /* XmRXrtGearArrowType */

#ifndef   XmRXrtGearBorderLocation
#define   XmRXrtGearBorderLocation             "XrtGearBorderLocation"
#endif /* XmRXrtGearBorderLocation */

#ifndef   XmRXrtGearBorderType
#define   XmRXrtGearBorderType                 "XrtGearBorderType"
#endif /* XmRXrtGearBorderType */

#ifndef   XmRXrtGearChildType
#define   XmRXrtGearChildType                  "XrtGearChildType"
#endif /* XmRXrtGearChildType */

#ifndef   XmRXrtGearColumnResizePolicy
#define   XmRXrtGearColumnResizePolicy         "XrtGearColumnResizePolicy"
#endif /* XmRXrtGearColumnResizePolicy */

#ifndef   XmRXrtGearDisplayPolicy
#define   XmRXrtGearDisplayPolicy              "XrtGearDisplayPolicy"
#endif /* XmRXrtGearDisplayPolicy */

#ifndef   XmRXrtGearImportPolicy
#define   XmRXrtGearImportPolicy               "XrtGearImportPolicy"
#endif /* XmRXrtGearImportPolicy */

#ifndef   XmRXrtGearIndicator
#define   XmRXrtGearIndicator                  "XrtGearIndicator"
#endif /* XmRXrtGearIndicator */

#ifndef   XmRXrtGearLineStyle
#define   XmRXrtGearLineStyle                  "XrtGearLineStyle"
#endif /* XmRXrtGearLineStyle */

#ifndef   XmRXrtGearMenuAlignment
#define   XmRXrtGearMenuAlignment              "XrtGearMenuAlignment"
#endif /* XmRXrtGearMenuAlignment */

#ifndef   XmRXrtGearMovePolicy
#define   XmRXrtGearMovePolicy                 "XrtGearMovePolicy"
#endif /* XmRXrtGearMovePolicy */

#ifndef   XmRXrtGearPageAttachPolicy
#define   XmRXrtGearPageAttachPolicy           "XrtGearPageAttachPolicy"
#endif /* XmRXrtGearPageAttachPolicy */

#ifndef   XmRXrtGearProgressType
#define   XmRXrtGearProgressType               "XrtGearProgressType"
#endif /* XmRXrtGearProgressType */

#ifndef   XmRXrtGearRotation
#define   XmRXrtGearRotation                   "XrtGearRotation"
#endif /* XmRXrtGearRotation */

#ifndef   XmRXrtGearSearchPolicy
#define   XmRXrtGearSearchPolicy               "XrtGearSearchPolicy"
#endif /* XmRXrtGearSearchPolicy */

#ifndef   XmRXrtGearSelectionPolicy
#define   XmRXrtGearSelectionPolicy            "XrtGearSelectionPolicy"
#endif /* XmRXrtGearSelectionPolicy */

#ifndef   XmRXrtGearSelectionRestrictions
#define   XmRXrtGearSelectionRestrictions      "XrtGearSelectionRestrictions"
#endif /* XmRXrtGearSelectionRestrictions */

#ifndef   XmRXrtGearSizingPolicy
#define   XmRXrtGearSizingPolicy               "XrtGearSizingPolicy"
#endif /* XmRXrtGearSizingPolicy */

#ifndef   XmRXrtGearStringLayout
#define   XmRXrtGearStringLayout               "XrtGearStringLayout"
#endif /* XmRXrtGearStringLayout */

#ifndef   XmRXrtGearStyle
#define   XmRXrtGearStyle                      "XrtGearStyle"
#endif /* XmRXrtGearStyle */

#ifndef   XmRXrtGearTabRotation
#define   XmRXrtGearTabRotation                "XrtGearTabRotation"
#endif /* XmRXrtGearTabRotation */

#ifndef   XmRXrtGearTabSide
#define   XmRXrtGearTabSide                    "XrtGearTabSide"
#endif /* XmRXrtGearTabSide */

#ifndef   XmRXrtGearTextHorizClipPolicy
#define   XmRXrtGearTextHorizClipPolicy        "XrtGearTextHorizClipPolicy"
#endif /* XmRXrtGearTextHorizClipPolicy */

#ifndef   XmRXrtGearType
#define   XmRXrtGearType                       "XrtGearType"
#endif /* XmRXrtGearType */

#ifndef   XmRXrtGearWidgetResizePolicy
#define   XmRXrtGearWidgetResizePolicy         "XrtGearWidgetResizePolicy"
#endif /* XmRXrtGearWidgetResizePolicy */

#ifndef   XmRXrtGearColumn
#define   XmRXrtGearColumn                     "XrtGearColumn"
#endif /* XmRXrtGearColumn */

#ifndef   XmRXrtGearNodeStyle
#define   XmRXrtGearNodeStyle                  "XrtGearNodeStyle"
#endif /* XmRXrtGearNodeStyle */

#ifndef   XmRXrtGearState
#define   XmRXrtGearState                      "XrtGearState"
#endif /* XmRXrtGearState */

#ifndef   XmRXrtGearUlong
#define   XmRXrtGearUlong                      "XrtGearUlong"
#endif /* XmRXrtGearUlong */

#ifndef   XmRXrtGearWidget
#define   XmRXrtGearWidget                     "XrtGearWidget"
#endif /* XmRXrtGearWidget */

#ifndef   XmRXrtGearActivePageNumber
#define   XmRXrtGearActivePageNumber           "XrtGearActivePageNumber"
#endif /* XmRXrtGearActivePageNumber */

#ifndef   XmRXrtGearFolderStateMask
#define   XmRXrtGearFolderStateMask            "XrtGearFolderStateMask"
#endif /* XmRXrtGearFolderStateMask */

#ifndef   XmRXrtGearIcon
#define   XmRXrtGearIcon                       "XrtGearIcon"
#endif /* XmRXrtGearIcon */

#ifndef   XmRXrtGearIndicatorMaskList
#define   XmRXrtGearIndicatorMaskList          "XrtGearIndicatorMaskList"
#endif /* XmRXrtGearIndicatorMaskList */

#ifndef   XmRXrtGearIndicatorPixmapList
#define   XmRXrtGearIndicatorPixmapList        "XrtGearIndicatorPixmapList"
#endif /* XmRXrtGearIndicatorPixmapList */

#ifndef   XmRXrtGearMask
#define   XmRXrtGearMask                       "XrtGearMask"
#endif /* XmRXrtGearMask */

#ifndef   XmRXrtGearPSFontMapList
#define   XmRXrtGearPSFontMapList              "XrtGearPSFontMapList"
#endif /* XmRXrtGearPSFontMapList */

#ifndef   XmRXrtGearPixmap
#define   XmRXrtGearPixmap                     "XrtGearPixmap"
#endif /* XmRXrtGearPixmap */

#ifndef   XmRXrtGearString
#define   XmRXrtGearString                     "XrtGearString"
#endif /* XmRXrtGearString */

#endif /* XRTGEAR_RELEASE < 2000 */

/*
** XrtGear: Added in Volume 11
*/

#if       XRTGEAR_RELEASE < 2020

#ifndef   XmNxrtGearVisibleItemCount
#define   XmNxrtGearVisibleItemCount           "xrtGearVisibleItemCount"
#endif /* XmNxrtGearVisibleItemCount */

#endif /* XRTGEAR_RELEASE < 2020 */

/*
** XrtField: Added from Volume 13 Onwards
*/

#if       XRTGEAR_RELEASE < 3000 

#ifndef   XmNxrtGearFolderShortcutShow
#define   XmNxrtGearFolderShortcutShow                "xrtGearFolderShortcutShow"
#endif /* XmNxrtGearFolderShortcutShow */

#ifndef   XmNxrtGearShortcutColor
#define   XmNxrtGearShortcutColor                     "xrtGearShortcutColor"
#endif /* XmNxrtGearShortcutColor */

#ifndef   XmNxrtGearEditColumn
#define   XmNxrtGearEditColumn                        "xrtGearEditColumn"
#endif /* XmNxrtGearEditColumn */

#ifndef   XmNxrtGearEditNode
#define   XmNxrtGearEditNode                          "xrtGearEditNode"
#endif /* XmNxrtGearEditNode */

#ifndef   XmNxrtGearEditType
#define   XmNxrtGearEditType                          "xrtGearEditType"
#endif /* XmNxrtGearEditType */

#ifndef   XmNxrtGearEditor
#define   XmNxrtGearEditor                            "xrtGearEditor"
#endif /* XmNxrtGearEditor */

#ifndef   XmNxrtGearHighlightOnDrag
#define   XmNxrtGearHighlightOnDrag                   "xrtGearHighlightOnDrag"
#endif /* XmNxrtGearHighlightOnDrag */

#ifndef   XmNxrtGearNodeEnterCellCallback
#define   XmNxrtGearNodeEnterCellCallback             "xrtGearNodeEnterCellCallback"
#endif /* XmNxrtGearNodeEnterCellCallback */

#ifndef   XmNxrtGearNodeValidateCallback
#define   XmNxrtGearNodeValidateCallback              "xrtGearNodeValidateCallback"
#endif /* XmNxrtGearNodeValidateCallback */

#ifndef   XmNxrtGearTextEditor
#define   XmNxrtGearTextEditor                        "xrtGearTextEditor"
#endif /* XmNxrtGearTextEditor */

#ifndef   XmNxrtGearMaximum
#define   XmNxrtGearMaximum                           "xrtGearMaximum"
#endif /* XmNxrtGearMaximum */

#ifndef   XmNxrtGearMinimum
#define   XmNxrtGearMinimum                           "xrtGearMinimum"
#endif /* XmNxrtGearMinimum */

#ifndef   XmNxrtGearPaneResizeCallback
#define   XmNxrtGearPaneResizeCallback                "xrtGearPaneResizeCallback"
#endif /* XmNxrtGearPaneResizeCallback */

#ifndef   XmNxrtGearRecomputeSize
#define   XmNxrtGearRecomputeSize                     "xrtGearRecomputeSize"
#endif /* XmNxrtGearRecomputeSize */

#ifndef   XmNxrtGearSashHeight
#define   XmNxrtGearSashHeight                        "xrtGearSashHeight"
#endif /* XmNxrtGearSashHeight */

#ifndef   XmNxrtGearSashIndent
#define   XmNxrtGearSashIndent                        "xrtGearSashIndent"
#endif /* XmNxrtGearSashIndent */

#ifndef   XmNxrtGearSashShadowThickness
#define   XmNxrtGearSashShadowThickness               "xrtGearSashShadowThickness"
#endif /* XmNxrtGearSashShadowThickness */

#ifndef   XmNxrtGearSashWidth
#define   XmNxrtGearSashWidth                         "xrtGearSashWidth"
#endif /* XmNxrtGearSashWidth */

#ifndef   XmNxrtGearSeparatorShow
#define   XmNxrtGearSeparatorShow                     "xrtGearSeparatorShow"
#endif /* XmNxrtGearSeparatorShow */

#ifndef   XmNxrtGearSkipAdjust
#define   XmNxrtGearSkipAdjust                        "xrtGearSkipAdjust"
#endif /* XmNxrtGearSkipAdjust */

#ifndef   XmNxrtGearAutoComplete
#define   XmNxrtGearAutoComplete                      "xrtGearAutoComplete"
#endif /* XmNxrtGearAutoComplete */

#ifndef   XmNxrtGearActive
#define   XmNxrtGearActive                            "xrtGearActive"
#endif /* XmNxrtGearActive */

#ifndef   XRTGEAR_ALIGNER_TOPRIGHT
#define   XRTGEAR_ALIGNER_TOPRIGHT                    3
#define   XRTGEAR_ALIGNER_MIDDLERIGHT                 4
#define   XRTGEAR_ALIGNER_BOTTOMRIGHT                 5
#define   XRTGEAR_ALIGNER_TOPCENTER                   6
#define   XRTGEAR_ALIGNER_MIDDLECENTER                7
#define   XRTGEAR_ALIGNER_BOTTOMCENTER                8
#define   XRTGEAR_ALIGNER_TOPLEFT                     9
#define   XRTGEAR_ALIGNER_MIDDLELEFT                 10
#define   XRTGEAR_ALIGNER_BOTTOMLEFT                 11
#endif /* XRTGEAR_ALIGNER_BOTTOMLEFT */

#ifndef   XRTGEAR_EDIT_TYPE_WINDOWS
#define   XRTGEAR_EDIT_TYPE_WINDOWS                   0
#define   XRTGEAR_EDIT_TYPE_MOTIF                     1
#endif /* XRTGEAR_EDIT_TYPE_MOTIF */

#ifndef   XmRXrtGearEditType
#define   XmRXrtGearEditType                          "XrtGearEditType"
#endif /* XmRXrtGearEditType */

#endif /* XRTGEAR_RELEASE < 3000 */

/*
** Xrt3d: Added from Volume 11 Onwards
*/

#if       XRT3D_RELEASE < 2012

#ifndef   XtNxrt3dPreviewMethod
#define   XtNxrt3dPreviewMethod   "xrt3dPreviewMethod"
#define   XtRXrt3dPreviewMethod   "Xrt3dPreviewMethod"
#define   XRT3D_PREVIEW_CUBE       0
#define   XRT3D_PREVIEW_FULL       100
#endif /* XtNxrt3dPreviewMethod */

#endif /* XRT3D_RELEASE < 2012 */

/*
** Xrt3d: Added from Volume 13 Onwards
*/

#if       XRT3D_RELEASE < 3000

#ifndef   XtNxrt3dTextAttachIndexPoint
#define   XtNxrt3dTextAttachIndexPoint                "xrt3dTextAttachIndexPoint"
#endif /* XtNxrt3dTextAttachIndexPoint */

#ifndef   XtNxrt3dTextAttachIndexSeries
#define   XtNxrt3dTextAttachIndexSeries               "xrt3dTextAttachIndexSeries"
#endif /* XtNxrt3dTextAttachIndexSeries */

#ifndef   XtNxrt3dTextImage
#define   XtNxrt3dTextImage                           "xrt3dTextImage"
#endif /* XtNxrt3dTextImage */

#ifndef   XtNxrt3dTextImageLayout
#define   XtNxrt3dTextImageLayout                     "xrt3dTextImageLayout"
#endif /* XtNxrt3dTextImageLayout */

#ifndef   XtNxrt3dTextImageMinimumSize
#define   XtNxrt3dTextImageMinimumSize                "xrt3dTextImageMinimumSize"
#endif /* XtNxrt3dTextImageMinimumSize */

#ifndef   XtNxrt3dColorFunc
#define   XtNxrt3dColorFunc                           "xrt3dColorFunc"
#endif /* XtNxrt3dColorFunc */

#ifndef   XtNxrt3dDataStyles
#define   XtNxrt3dDataStyles                          "xrt3dDataStyles"
#endif /* XtNxrt3dDataStyles */

#ifndef   XtNxrt3dDataStylesUseDefault
#define   XtNxrt3dDataStylesUseDefault                "xrt3dDataStylesUseDefault"
#endif /* XtNxrt3dDataStylesUseDefault */

#ifndef   XtNxrt3dDrawDropLines
#define   XtNxrt3dDrawDropLines                       "xrt3dDrawDropLines"
#endif /* XtNxrt3dDrawDropLines */

#ifndef   XtNxrt3dFooterImage
#define   XtNxrt3dFooterImage                         "xrt3dFooterImage"
#endif /* XtNxrt3dFooterImage */

#ifndef   XtNxrt3dFooterImageLayout
#define   XtNxrt3dFooterImageLayout                   "xrt3dFooterImageLayout"
#endif /* XtNxrt3dFooterImageLayout */

#ifndef   XtNxrt3dFooterImageMinimumSize
#define   XtNxrt3dFooterImageMinimumSize              "xrt3dFooterImageMinimumSize"
#endif /* XtNxrt3dFooterImageMinimumSize */

#ifndef   XtNxrt3dGraphImage
#define   XtNxrt3dGraphImage                          "xrt3dGraphImage"
#endif /* XtNxrt3dGraphImage */

#ifndef   XtNxrt3dGraphImageLayout
#define   XtNxrt3dGraphImageLayout                    "xrt3dGraphImageLayout"
#endif /* XtNxrt3dGraphImageLayout */

#ifndef   XtNxrt3dHeaderImage
#define   XtNxrt3dHeaderImage                         "xrt3dHeaderImage"
#endif /* XtNxrt3dHeaderImage */

#ifndef   XtNxrt3dHeaderImageLayout
#define   XtNxrt3dHeaderImageLayout                   "xrt3dHeaderImageLayout"
#endif /* XtNxrt3dHeaderImageLayout */

#ifndef   XtNxrt3dHeaderImageMinimumSize
#define   XtNxrt3dHeaderImageMinimumSize              "xrt3dHeaderImageMinimumSize"
#endif /* XtNxrt3dHeaderImageMinimumSize */

#ifndef   XtNxrt3dImage
#define   XtNxrt3dImage                               "xrt3dImage"
#endif /* XtNxrt3dImage */

#ifndef   XtNxrt3dImageLayout
#define   XtNxrt3dImageLayout                         "xrt3dImageLayout"
#endif /* XtNxrt3dImageLayout */

#ifndef   XtNxrt3dLegendDistnRange
#define   XtNxrt3dLegendDistnRange                    "xrt3dLegendDistnRange"
#endif /* XtNxrt3dLegendDistnRange */

#ifndef   XtNxrt3dLegendImage
#define   XtNxrt3dLegendImage                         "xrt3dLegendImage"
#endif /* XtNxrt3dLegendImage */

#ifndef   XtNxrt3dLegendImageLayout
#define   XtNxrt3dLegendImageLayout                   "xrt3dLegendImageLayout"
#endif /* XtNxrt3dLegendImageLayout */

#ifndef   XtNxrt3dLegendLabelFilter
#define   XtNxrt3dLegendLabelFilter                   "xrt3dLegendLabelFilter"
#endif /* XtNxrt3dLegendLabelFilter */

#ifndef   XtNxrt3dLegendTitle
#define   XtNxrt3dLegendTitle                         "xrt3dLegendTitle"
#endif /* XtNxrt3dLegendTitle */

#ifndef   XtNxrt3dXGridLineStyle
#define   XtNxrt3dXGridLineStyle                      "xrt3dXGridLineStyle"
#endif /* XtNxrt3dXGridLineStyle */

#ifndef   XtNxrt3dXGridLineStyleUseDefault
#define   XtNxrt3dXGridLineStyleUseDefault            "xrt3dXGridLineStyleUseDefault"
#endif /* XtNxrt3dXGridLineStyleUseDefault */

#ifndef   XtNxrt3dYGridLineStyle
#define   XtNxrt3dYGridLineStyle                      "xrt3dYGridLineStyle"
#endif /* XtNxrt3dYGridLineStyle */

#ifndef   XtNxrt3dYGridLineStyleUseDefault
#define   XtNxrt3dYGridLineStyleUseDefault            "xrt3dYGridLineStyleUseDefault"
#endif /* XtNxrt3dYGridLineStyleUseDefault */

#ifndef   XtNxrt3dZGridLineStyle
#define   XtNxrt3dZGridLineStyle                      "xrt3dZGridLineStyle"
#endif /* XtNxrt3dZGridLineStyle */

#ifndef   XtNxrt3dZGridLineStyleUseDefault
#define   XtNxrt3dZGridLineStyleUseDefault            "xrt3dZGridLineStyleUseDefault"
#endif /* XtNxrt3dZGridLineStyleUseDefault */

#ifndef   XRT3D_DISTN_RANGE_DATA
#define   XRT3D_DISTN_RANGE_DATA                      1
#define   XRT3D_DISTN_RANGE_ALL                       2
#endif /* XRT3D_DISTN_RANGE_DATA */

#ifndef   XRT3D_IMAGELAYOUT_CENTERED
#define   XRT3D_IMAGELAYOUT_CENTERED                  1
#define   XRT3D_IMAGELAYOUT_TILED                     2
#endif /* XRT3D_IMAGELAYOUT_TILED */

#ifndef   XRT3D_TYPE_SCATTER
#define   XRT3D_TYPE_SCATTER                          2
#endif /* XRT3D_TYPE_SCATTER */

#ifndef   XtRXrt3dDistnRange
#define   XtRXrt3dDistnRange                          "Xrt3dDistnRange"
#endif /* XtRXrt3dDistnRange */

#ifndef   XtRXrt3dImageLayout
#define   XtRXrt3dImageLayout                         "Xrt3dImageLayout"
#endif /* XtRXrt3dImageLayout */

#ifndef   XtRXrt3dColor
#define   XtRXrt3dColor                               "Xrt3dColor"
#endif /* XtRXrt3dColor */

#ifndef   XtRXrt3dString
#define   XtRXrt3dString                              "Xrt3dString"
#endif /* XtRXrt3dString */

#ifndef   XtRXrt3dDataStyles
#define   XtRXrt3dDataStyles                          "Xrt3dDataStyles"
#endif /* XtRXrt3dDataStyles */

#ifndef   XtRXrt3dImage
#define   XtRXrt3dImage                               "Xrt3dImage"
#endif /* XtRXrt3dImage */

#ifndef   XtRXrt3dLineStyle
#define   XtRXrt3dLineStyle                           "Xrt3dLineStyle"
#endif /* XtRXrt3dLineStyle */

#endif /* XRT3D_RELEASE < 3000 */

/* 
** XrtGraph: Added from Volume 11 Onwards 
*/

#ifndef   XRTGRAPH_RELEASE
#define   XRTGRAPH_RELEASE        XRT_RELEASE
#endif /* XRTGRAPH_RELEASE */

#if       XRTGRAPH_RELEASE < 3000

#ifndef   XtRXrtAngleUnit
#define   XtRXrtAngleUnit         "XrtAngleUnit"
#endif /* XtRXrtAngleUnit */

#ifndef   XtNxrtAngleUnit
#define   XtNxrtAngleUnit         "xrtAngleUnit"
#endif /* XtNxrtAngleUnit */

#ifndef   XRT_ANGLE_DEGREES
#define   XRT_ANGLE_DEGREES       1
#define   XRT_ANGLE_RADIANS       2
#define   XRT_ANGLE_GRADS         3
#endif /* XRT_ANGLE_DEGREES */

#ifndef   XtRXrtMarkerMethod
#define   XtRXrtMarkerMethod      "XrtMarkerMethod"
#endif /* XtRXrtMarkerMethod */

#ifndef   XtNxrtXMarkerMethod
#define   XtNxrtXMarkerMethod     "xrtXMarkerMethod"
#endif /* XtNxrtXMarkerMethod */

#ifndef   XRT_MARKER_SET_POINT
#define   XRT_MARKER_SET_POINT    1
#define   XRT_MARKER_VALUE        2
#endif /* XRT_MARKER_SET_POINT */

#ifndef   XtRXrtShading
#define   XtRXrtShading           "XrtShading"
#endif /* XtRXrtShading */

#ifndef   XtNxrtGraph3dShading
#define   XtNxrtGraph3dShading    "xrtGraph3dShading"
#endif /* XtNxrtGraph3dShading */

#ifndef   XRT_SHADING_COLOR
#define   XRT_SHADING_COLOR       1
#define   XRT_SHADING_DITHERED    2
#define   XRT_SHADING_NONE        3
#endif /* XRT_SHADING_COLOR */

#ifndef   XtNxrtBorder
#define   XtNxrtBorder                    "xrtBorder"
#endif /* XtNxrtBorder */

#ifndef   XtNxrtCandleComplex
#define   XtNxrtCandleComplex             "xrtCandleComplex"
#endif /* XtNxrtCandleComplex */

#ifndef   XtNxrtDataAreaBackgroundColor
#define   XtNxrtDataAreaBackgroundColor   "xrtDataAreaBackgroundColor"
#endif /* XtNxrtDataAreaBackgroundColor */

#ifndef   XtNxrtDataAreaForegroundColor
#define   XtNxrtDataAreaForegroundColor   "xrtDataAreaForegroundColor"
#endif /* XtNxrtDataAreaForegroundColor */

#ifndef   XtNxrtGraphShowOutlines
#define   XtNxrtGraphShowOutlines         "xrtGraphShowOutlines"
#endif /* XtNxrtGraphShowOutlines */

#ifndef   XtNxrtHiLoCloseShow
#define   XtNxrtHiLoCloseShow             "xrtHiLoCloseShow"
#endif /* XtNxrtHiLoCloseShow */

#ifndef   XtNxrtHiLoOpenCloseFullWidth
#define   XtNxrtHiLoOpenCloseFullWidth    "xrtHiLoOpenCloseFullWidth"
#endif /* XtNxrtHiLoOpenCloseFullWidth */

#ifndef   XtNxrtHiLoOpenShow
#define   XtNxrtHiLoOpenShow              "xrtHiLoOpenShow"
#endif /* XtNxrtHiLoOpenShow */

#ifndef   XtNxrtPolarHalfRange
#define   XtNxrtPolarHalfRange            "xrtPolarHalfRange"
#endif /* XtNxrtPolarHalfRange */

#ifndef   XtNxrtXAxisLabelFormat
#define   XtNxrtXAxisLabelFormat          "xrtXAxisLabelFormat"
#endif /* XtNxrtXAxisLabelFormat */

#ifndef   XtNxrtXMarkerDataStyle
#define   XtNxrtXMarkerDataStyle          "xrtXMarkerDataStyle"
#endif /* XtNxrtXMarkerDataStyle */

#ifndef   XtNxrtXMarkerDataStyleUseDefault
#define   XtNxrtXMarkerDataStyleUseDefault "xrtXMarkerDataStyleUseDefault"
#endif /* XtNxrtXMarkerDataStyleUseDefault */

#ifndef   XtNxrtXOriginBase
#define   XtNxrtXOriginBase                "xrtXOriginBase"
#endif /* XtNxrtXOriginBase */

#ifndef   XtNxrtY2AnnoPlacement
#define   XtNxrtY2AnnoPlacement            "xrtY2AnnoPlacement"
#endif /* XtNxrtY2AnnoPlacement */

#ifndef   XtNxrtY2AnnotationAngle
#define   XtNxrtY2AnnotationAngle          "xrtY2AnnotationAngle"
#endif /* XtNxrtY2AnnotationAngle */

#ifndef   XtNxrtY2AnnotationAngleUseDefault
#define   XtNxrtY2AnnotationAngleUseDefault "xrtY2AnnotationAngleUseDefault"
#endif /* XtNxrtY2AnnotationAngleUseDefault */

#ifndef   XtNxrtY2Axis100Percent
#define   XtNxrtY2Axis100Percent            "xrtY2Axis100Percent"
#endif /* XtNxrtY2Axis100Percent */

#ifndef   XtNxrtY2AxisLabelFormat
#define   XtNxrtY2AxisLabelFormat           "xrtY2AxisLabelFormat"
#endif /* XtNxrtY2AxisLabelFormat */

#ifndef   XtNxrtY2Grid
#define   XtNxrtY2Grid                      "xrtY2Grid"
#endif /* XtNxrtY2Grid */

#ifndef   XtNxrtY2GridDataStyle
#define   XtNxrtY2GridDataStyle             "xrtY2GridDataStyle"
#endif /* XtNxrtY2GridDataStyle */

#ifndef   XtNxrtY2GridDataStyleUseDefault
#define   XtNxrtY2GridDataStyleUseDefault   "xrtY2GridDataStyleUseDefault"
#endif /* XtNxrtY2GridDataStyleUseDefault */

#ifndef   XtNxrtY2GridUseDefault
#define   XtNxrtY2GridUseDefault            "xrtY2GridUseDefault"
#endif /* XtNxrtY2GridUseDefault */

#ifndef   XtNxrtY2Origin
#define   XtNxrtY2Origin                    "xrtY2Origin"
#endif /* XtNxrtY2Origin */

#ifndef   XtNxrtY2OriginPlacement
#define   XtNxrtY2OriginPlacement           "xrtY2OriginPlacement"
#endif /* XtNxrtY2OriginPlacement */

#ifndef   XtNxrtY2OriginUseDefault
#define   XtNxrtY2OriginUseDefault          "xrtY2OriginUseDefault"
#endif /* XtNxrtY2OriginUseDefault */

#ifndef   XtNxrtYAnnotationAngle
#define   XtNxrtYAnnotationAngle            "xrtYAnnotationAngle"
#endif /* XtNxrtYAnnotationAngle */

#ifndef   XtNxrtYAnnotationAngleUseDefault
#define   XtNxrtYAnnotationAngleUseDefault  "xrtYAnnotationAngleUseDefault"
#endif /* XtNxrtYAnnotationAngleUseDefault */

#ifndef   XtNxrtYAxis100Percent
#define   XtNxrtYAxis100Percent             "xrtYAxis100Percent"
#endif /* XtNxrtYAxis100Percent */

#ifndef   XtNxrtYAxisLabelFormat
#define   XtNxrtYAxisLabelFormat            "xrtYAxisLabelFormat"
#endif /* XtNxrtYAxisLabelFormat */

#ifndef   XtNxrtYMarkerDataStyle
#define   XtNxrtYMarkerDataStyle            "xrtYMarkerDataStyle"
#endif /* XtNxrtYMarkerDataStyle */

#ifndef   XtNxrtYMarkerDataStyleUseDefault
#define   XtNxrtYMarkerDataStyleUseDefault  "xrtYMarkerDataStyleUseDefault"
#endif /* XtNxrtYMarkerDataStyleUseDefault */

#ifndef   XtNxrtZoomAxisCallback
#define   XtNxrtZoomAxisCallback            "xrtZoomAxisCallback"
#endif /* XtNxrtZoomAxisCallback */

#endif /* XRTGRAPH_RELEASE < 3000 */

/*
** XrtGraph: Removed from Volume 11 Onwards
*/

#if       XRTGRAPH_RELEASE > 2040

#ifndef   XtNxrtTransposeData
#define   XtNxrtTransposeData       "xrtTransposeData"
#endif /* XtNxrtTransposeData */

#endif /* XRTGRAPH_RELEASE > 2040 */

/* 
** XrtGraph: Added from Volume 13 Onwards 
*/

#if       XRTGRAPH_RELEASE < 4000

#ifndef   XtNxrtBubbleMax
#define   XtNxrtBubbleMax                             "xrtBubbleMax"
#endif /* XtNxrtBubbleMax */

#ifndef   XtNxrtBubbleMethod
#define   XtNxrtBubbleMethod                          "xrtBubbleMethod"
#endif /* XtNxrtBubbleMethod */

#ifndef   XtNxrtBubbleMin
#define   XtNxrtBubbleMin                             "xrtBubbleMin"
#endif /* XtNxrtBubbleMin */

#ifndef   XtNxrtColorFunc
#define   XtNxrtColorFunc                             "xrtColorFunc"
#endif /* XtNxrtColorFunc */

#ifndef   XtNxrtDataAreaImage
#define   XtNxrtDataAreaImage                         "xrtDataAreaImage"
#endif /* XtNxrtDataAreaImage */

#ifndef   XtNxrtDataAreaImageLayout
#define   XtNxrtDataAreaImageLayout                   "xrtDataAreaImageLayout"
#endif /* XtNxrtDataAreaImageLayout */

#ifndef   XtNxrtExtraDefaultDataStyles
#define   XtNxrtExtraDefaultDataStyles                "xrtExtraDefaultDataStyles"
#endif /* XtNxrtExtraDefaultDataStyles */

#ifndef   XtNxrtFooterImage
#define   XtNxrtFooterImage                           "xrtFooterImage"
#endif /* XtNxrtFooterImage */

#ifndef   XtNxrtFooterImageLayout
#define   XtNxrtFooterImageLayout                     "xrtFooterImageLayout"
#endif /* XtNxrtFooterImageLayout */

#ifndef   XtNxrtFooterImageMinimumSize
#define   XtNxrtFooterImageMinimumSize                "xrtFooterImageMinimumSize"
#endif /* XtNxrtFooterImageMinimumSize */

#ifndef   XtNxrtGraphImage
#define   XtNxrtGraphImage                            "xrtGraphImage"
#endif /* XtNxrtGraphImage */

#ifndef   XtNxrtGraphImageLayout
#define   XtNxrtGraphImageLayout                      "xrtGraphImageLayout"
#endif /* XtNxrtGraphImageLayout */

#ifndef   XtNxrtHeaderImage
#define   XtNxrtHeaderImage                           "xrtHeaderImage"
#endif /* XtNxrtHeaderImage */

#ifndef   XtNxrtHeaderImageLayout
#define   XtNxrtHeaderImageLayout                     "xrtHeaderImageLayout"
#endif /* XtNxrtHeaderImageLayout */

#ifndef   XtNxrtHeaderImageMinimumSize
#define   XtNxrtHeaderImageMinimumSize                "xrtHeaderImageMinimumSize"
#endif /* XtNxrtHeaderImageMinimumSize */

#ifndef   XtNxrtImage
#define   XtNxrtImage                                 "xrtImage"
#endif /* XtNxrtImage */

#ifndef   XtNxrtImageLayout
#define   XtNxrtImageLayout                           "xrtImageLayout"
#endif /* XtNxrtImageLayout */

#ifndef   XtNxrtIsStacked
#define   XtNxrtIsStacked                             "xrtIsStacked"
#endif /* XtNxrtIsStacked */

#ifndef   XtNxrtIsStacked2
#define   XtNxrtIsStacked2                            "xrtIsStacked2"
#endif /* XtNxrtIsStacked2 */

#ifndef   XtNxrtLegendImage
#define   XtNxrtLegendImage                           "xrtLegendImage"
#endif /* XtNxrtLegendImage */

#ifndef   XtNxrtLegendImageLayout
#define   XtNxrtLegendImageLayout                     "xrtLegendImageLayout"
#endif /* XtNxrtLegendImageLayout */

#ifndef   XtNxrtLegendReversed
#define   XtNxrtLegendReversed                        "xrtLegendReversed"
#endif /* XtNxrtLegendReversed */

#ifndef   XtNxrtLegendTitle
#define   XtNxrtLegendTitle                           "xrtLegendTitle"
#endif /* XtNxrtLegendTitle */

#ifndef   XtNxrtPieMergeMissingSlices
#define   XtNxrtPieMergeMissingSlices                 "xrtPieMergeMissingSlices"
#endif /* XtNxrtPieMergeMissingSlices */

#ifndef   XtNxrtPieStartAngle
#define   XtNxrtPieStartAngle                         "xrtPieStartAngle"
#endif /* XtNxrtPieStartAngle */

#ifndef   XtNxrtPolarAxisAllowNegatives
#define   XtNxrtPolarAxisAllowNegatives               "xrtPolarAxisAllowNegatives"
#endif /* XtNxrtPolarAxisAllowNegatives */

#ifndef   XtNxrtXAxisDataStyle
#define   XtNxrtXAxisDataStyle                        "xrtXAxisDataStyle"
#endif /* XtNxrtXAxisDataStyle */

#ifndef   XtNxrtXAxisDataStyleUseDefault
#define   XtNxrtXAxisDataStyleUseDefault              "xrtXAxisDataStyleUseDefault"
#endif /* XtNxrtXAxisDataStyleUseDefault */

#ifndef   XtNxrtY2AxisDataStyle
#define   XtNxrtY2AxisDataStyle                       "xrtY2AxisDataStyle"
#endif /* XtNxrtY2AxisDataStyle */

#ifndef   XtNxrtY2AxisDataStyleUseDefault
#define   XtNxrtY2AxisDataStyleUseDefault             "xrtY2AxisDataStyleUseDefault"
#endif /* XtNxrtY2AxisDataStyleUseDefault */

#ifndef   XtNxrtYAxisDataStyle
#define   XtNxrtYAxisDataStyle                        "xrtYAxisDataStyle"
#endif /* XtNxrtYAxisDataStyle */

#ifndef   XtNxrtYAxisDataStyleUseDefault
#define   XtNxrtYAxisDataStyleUseDefault              "xrtYAxisDataStyleUseDefault"
#endif /* XtNxrtYAxisDataStyleUseDefault */

#ifndef   XRT_BUBBLEMETHOD_DIAMETER
#define   XRT_BUBBLEMETHOD_DIAMETER                   1
#define   XRT_BUBBLEMETHOD_AREA                       2
#endif /* XRT_BUBBLEMETHOD_AREA */

#ifndef   XRT_IMAGELAYOUT_CENTERED
#define   XRT_IMAGELAYOUT_CENTERED                    1
#define   XRT_IMAGELAYOUT_TILED                       2
#endif /* XRT_IMAGELAYOUT_TILED */

#ifndef   XRT_TYPE_BUBBLE
#define   XRT_TYPE_BUBBLE                             12
#endif /* XRT_TYPE_BUBBLE */

#ifndef   XtRXrtBubbleMethod
#define   XtRXrtBubbleMethod                          "XrtBubbleMethod"
#endif /* XtRXrtBubbleMethod */

#ifndef   XtRXrtImageLayout
#define   XtRXrtImageLayout                           "XrtImageLayout"
#endif /* XtRXrtImageLayout */

#ifndef   XtRXrtColor
#define   XtRXrtColor                                 "XrtColor"
#endif /* XtRXrtColor */

#ifndef   XtRXrtImage
#define   XtRXrtImage                                 "XrtImage"
#endif /* XtRXrtImage */

#endif /* XRTGRAPH_RELEASE < 4000 */

/*
** XrtField: Added from Volume 11 Onwards
*/

#if       XRTFIELD_RELEASE < 1010 

#ifndef   XmNxrtComboArrowType
#define   XmNxrtComboArrowType         "xrtComboArrowType"
#endif /* XmNxrtComboArrowType */

#ifndef   XmNxrtComboSpacing
#define   XmNxrtComboSpacing           "xrtComboSpacing"
#endif /* XmNxrtComboSpacing */

#ifndef   XmNxrtFldMilleniumThreshold
#define   XmNxrtFldMilleniumThreshold  "xrtFldMilleniumThreshold"
#endif /* XmNxrtFldMilleniumThreshold */

#ifndef   XmNxrtSpinArrowType
#define   XmNxrtSpinArrowType          "xrtSpinArrowType"
#endif /* XmNxrtSpinArrowType */

#ifndef   XmNxrtSpinSpacing
#define   XmNxrtSpinSpacing            "xrtSpinSpacing"
#endif /* XmNxrtSpinSpacing */

#ifndef   XmNxrtFldMenuAlignment
#define   XmNxrtFldMenuAlignment       "xrtFldMenuAlignment"
#endif /* XmNxrtFldMenuAlignment */

#ifndef   XmNxrtFldMenuList
#define   XmNxrtFldMenuList            "xrtFldMenuList"
#endif /* XmNxrtFldMenuList */

#ifndef   XRTFLD_ARROW_NONE
#define   XRTFLD_ARROW_NONE            0
#define   XRTFLD_ARROW_WEDGE           1
#define   XRTFLD_ARROW_WITH_UNDERBAR   2
#define   XRTFLD_ARROW_CUSTOM          3
#endif /* XRTFLD_ARROW_NONE */

#ifndef   XRTFLD_MENU_ALIGN_BEGINNING
#define   XRTFLD_MENU_ALIGN_BEGINNING  0
#define   XRTFLD_MENU_ALIGN_BOTH       1
#define   XRTFLD_MENU_ALIGN_END        2
#endif /* XRTFLD_MENU_ALIGN_BEGINNING */

#ifndef   XRTFLD_SEARCH_SINGLE
#define   XRTFLD_SEARCH_SINGLE         0
#define   XRTFLD_SEARCH_MULTICHAR      1
#endif /* XRTFLD_SEARCH_SINGLE */

#ifndef   XmRxrtFldArrowType
#define   XmRxrtFldArrowType           "XrtFldArrowType"
#endif /* XmRxrtFldArrowType */

#ifndef   XmRxrtFldMenuAlignment
#define   XmRxrtFldMenuAlignment       "XrtFldMenuAlignment"
#endif /* XmRxrtFldMenuAlignment */

#ifndef   XmRXrtFldMenuAlignment
#define   XmRXrtFldMenuAlignment       "XrtFldMenuAlignment"
#endif /* XmRXrtFldMenuAlignment */

#ifndef   XmRxrtFldSearchPolicy
#define   XmRxrtFldSearchPolicy        "XrtFldSearchPolicy"
#endif /* XmRxrtFldSearchPolicy */

#endif /* XRTFIELD_RELEASE < 1010 */

/*
** XrtOutliner: Added from Volume 12 onwards
*/

#if       XRTFIELD_RELEASE < 1011 

#ifndef   XmNxrtGearNodeCheckForDuplicates
#define   XmNxrtGearNodeCheckForDuplicates      "xrtGearNodeCheckForDuplicates"
#endif /* XmNxrtGearNodeCheckForDuplicates */

#endif /* XRTFIELD_RELEASE < 1011 */

/*
** XrtField: Added from Volume 13 onwards
*/

#if       XRTFIELD_RELEASE < 2000 

#ifndef   XmNxrtFldCalendar
#define   XmNxrtFldCalendar                           "xrtFldCalendar"
#endif /* XmNxrtFldCalendar */

#ifndef   XmNxrtFldCalendarCallback
#define   XmNxrtFldCalendarCallback                   "xrtFldCalendarCallback"
#endif /* XmNxrtFldCalendarCallback */

#ifndef   XmNxrtFldSpinPolicy
#define   XmNxrtFldSpinPolicy                         "xrtFldSpinPolicy"
#endif /* XmNxrtFldSpinPolicy */

#ifndef   XmNxrtCalendarCellHighlightColor
#define   XmNxrtCalendarCellHighlightColor            "xrtCalendarCellHighlightColor"
#endif /* XmNxrtCalendarCellHighlightColor */

#ifndef   XmNxrtCalendarCellHighlightThickness
#define   XmNxrtCalendarCellHighlightThickness        "xrtCalendarCellHighlightThickness"
#endif /* XmNxrtCalendarCellHighlightThickness */

#ifndef   XmNxrtCalendarCellMargin
#define   XmNxrtCalendarCellMargin                    "xrtCalendarCellMargin"
#endif /* XmNxrtCalendarCellMargin */

#ifndef   XmNxrtCalendarCreateMonth
#define   XmNxrtCalendarCreateMonth                   "xrtCalendarCreateMonth"
#endif /* XmNxrtCalendarCreateMonth */

#ifndef   XmNxrtCalendarCreateTime
#define   XmNxrtCalendarCreateTime                    "xrtCalendarCreateTime"
#endif /* XmNxrtCalendarCreateTime */

#ifndef   XmNxrtCalendarCreateYear
#define   XmNxrtCalendarCreateYear                    "xrtCalendarCreateYear"
#endif /* XmNxrtCalendarCreateYear */

#ifndef   XmNxrtCalendarEnabled
#define   XmNxrtCalendarEnabled                       "xrtCalendarEnabled"
#endif /* XmNxrtCalendarEnabled */

#ifndef   XmNxrtCalendarFirstDayOfWeek
#define   XmNxrtCalendarFirstDayOfWeek                "xrtCalendarFirstDayOfWeek"
#endif /* XmNxrtCalendarFirstDayOfWeek */

#ifndef   XmNxrtCalendarFullWeekdayNames
#define   XmNxrtCalendarFullWeekdayNames              "xrtCalendarFullWeekdayNames"
#endif /* XmNxrtCalendarFullWeekdayNames */

#ifndef   XmNxrtCalendarHeaderBackground
#define   XmNxrtCalendarHeaderBackground              "xrtCalendarHeaderBackground"
#endif /* XmNxrtCalendarHeaderBackground */

#ifndef   XmNxrtCalendarHeaderFontList
#define   XmNxrtCalendarHeaderFontList                "xrtCalendarHeaderFontList"
#endif /* XmNxrtCalendarHeaderFontList */

#ifndef   XmNxrtCalendarHeaderForeground
#define   XmNxrtCalendarHeaderForeground              "xrtCalendarHeaderForeground"
#endif /* XmNxrtCalendarHeaderForeground */

#ifndef   XmNxrtCalendarHeaderNumChars
#define   XmNxrtCalendarHeaderNumChars                "xrtCalendarHeaderNumChars"
#endif /* XmNxrtCalendarHeaderNumChars */

#ifndef   XmNxrtCalendarMarginBottom
#define   XmNxrtCalendarMarginBottom                  "xrtCalendarMarginBottom"
#endif /* XmNxrtCalendarMarginBottom */

#ifndef   XmNxrtCalendarMarginLeft
#define   XmNxrtCalendarMarginLeft                    "xrtCalendarMarginLeft"
#endif /* XmNxrtCalendarMarginLeft */

#ifndef   XmNxrtCalendarMarginRight
#define   XmNxrtCalendarMarginRight                   "xrtCalendarMarginRight"
#endif /* XmNxrtCalendarMarginRight */

#ifndef   XmNxrtCalendarMarginTop
#define   XmNxrtCalendarMarginTop                     "xrtCalendarMarginTop"
#endif /* XmNxrtCalendarMarginTop */

#ifndef   XmNxrtCalendarMaxRollDate
#define   XmNxrtCalendarMaxRollDate                   "xrtCalendarMaxRollDate"
#endif /* XmNxrtCalendarMaxRollDate */

#ifndef   XmNxrtCalendarMinRollDate
#define   XmNxrtCalendarMinRollDate                   "xrtCalendarMinRollDate"
#endif /* XmNxrtCalendarMinRollDate */

#ifndef   XmNxrtCalendarModifyCallback
#define   XmNxrtCalendarModifyCallback                "xrtCalendarModifyCallback"
#endif /* XmNxrtCalendarModifyCallback */

#ifndef   XmNxrtCalendarSelectedBackground
#define   XmNxrtCalendarSelectedBackground            "xrtCalendarSelectedBackground"
#endif /* XmNxrtCalendarSelectedBackground */

#ifndef   XmNxrtCalendarSelectedForeground
#define   XmNxrtCalendarSelectedForeground            "xrtCalendarSelectedForeground"
#endif /* XmNxrtCalendarSelectedForeground */

#ifndef   XmNxrtCalendarSpecialDayBackground
#define   XmNxrtCalendarSpecialDayBackground          "xrtCalendarSpecialDayBackground"
#endif /* XmNxrtCalendarSpecialDayBackground */

#ifndef   XmNxrtCalendarSpecialDayForeground
#define   XmNxrtCalendarSpecialDayForeground          "xrtCalendarSpecialDayForeground"
#endif /* XmNxrtCalendarSpecialDayForeground */

#ifndef   XmNxrtCalendarSpecialDays
#define   XmNxrtCalendarSpecialDays                   "xrtCalendarSpecialDays"
#endif /* XmNxrtCalendarSpecialDays */

#ifndef   XmNxrtCalendarValue
#define   XmNxrtCalendarValue                         "xrtCalendarValue"
#endif /* XmNxrtCalendarValue */

#ifndef   XmNxrtCalendarValueLong
#define   XmNxrtCalendarValueLong                     "xrtCalendarValueLong"
#endif /* XmNxrtCalendarValueLong */

#ifndef   XmNxrtFldAutoComplete
#define   XmNxrtFldAutoComplete                       "xrtFldAutoComplete"
#endif /* XmNxrtFldAutoComplete */

#ifndef   XmNxrtFldCreatePopups
#define   XmNxrtFldCreatePopups                       "xrtFldCreatePopups"
#endif /* XmNxrtFldCreatePopups */

#ifndef   XmNxrtFldPopupType
#define   XmNxrtFldPopupType                          "xrtFldPopupType"
#endif /* XmNxrtFldPopupType */

#ifndef   XRTFLD_POPUP_PICKLIST
#define   XRTFLD_POPUP_PICKLIST                       0
#define   XRTFLD_POPUP_CALENDAR                       1
#endif /* XRTFLD_POPUP_CALENDAR */

#ifndef   XRTFLD_SPIN_FIELD
#define   XRTFLD_SPIN_FIELD                           0
#define   XRTFLD_SPIN_SUBFIELD                        1
#define   XRTFLD_SPIN_WRAP                            2
#endif /* XRTFLD_SPIN_WRAP */

#ifndef   XmRxrtFldPopupType
#define   XmRxrtFldPopupType                          "xrtFldPopupType"
#endif /* XmRxrtFldPopupType */

#ifndef   XmRxrtFldSpinPolicy
#define   XmRxrtFldSpinPolicy                         "xrtFldSpinPolicy"
#endif /* XmRxrtFldSpinPolicy */

#ifndef   XmRxrtCalendarSpecialDays
#define   XmRxrtCalendarSpecialDays                   "xrtCalendarSpecialDays"
#endif /* XmRxrtCalendarSpecialDays */

#endif /* XRTFIELD_RELEASE < 2000 */

/*
** XrtTable: Added from Volume 13 Onwards
*/

#if       XRTTABLE_RELEASE < 3000 

#ifndef   XmNxrtTblCurrencyPickListContext
#define   XmNxrtTblCurrencyPickListContext            "xrtTblCurrencyPickListContext"
#endif /* XmNxrtTblCurrencyPickListContext */

#ifndef   XmNxrtTblCurrencyPickListSeries
#define   XmNxrtTblCurrencyPickListSeries             "xrtTblCurrencyPickListSeries"
#endif /* XmNxrtTblCurrencyPickListSeries */

#ifndef   XmNxrtTblDatePickListContext
#define   XmNxrtTblDatePickListContext                "xrtTblDatePickListContext"
#endif /* XmNxrtTblDatePickListContext */

#ifndef   XmNxrtTblDatePickListSeries
#define   XmNxrtTblDatePickListSeries                 "xrtTblDatePickListSeries"
#endif /* XmNxrtTblDatePickListSeries */

#ifndef   XmNxrtTblFloatPickListContext
#define   XmNxrtTblFloatPickListContext               "xrtTblFloatPickListContext"
#endif /* XmNxrtTblFloatPickListContext */

#ifndef   XmNxrtTblFloatPickListSeries
#define   XmNxrtTblFloatPickListSeries                "xrtTblFloatPickListSeries"
#endif /* XmNxrtTblFloatPickListSeries */

#ifndef   XmNxrtTblIntPickListContext
#define   XmNxrtTblIntPickListContext                 "xrtTblIntPickListContext"
#endif /* XmNxrtTblIntPickListContext */

#ifndef   XmNxrtTblIntPickListSeries
#define   XmNxrtTblIntPickListSeries                  "xrtTblIntPickListSeries"
#endif /* XmNxrtTblIntPickListSeries */

#ifndef   XmNxrtTblPreviewScrolling
#define   XmNxrtTblPreviewScrolling                   "xrtTblPreviewScrolling"
#endif /* XmNxrtTblPreviewScrolling */

#ifndef   XmNxrtTblResizeToCell
#define   XmNxrtTblResizeToCell                       "xrtTblResizeToCell"
#endif /* XmNxrtTblResizeToCell */

#ifndef   XmNxrtTblSensitiveContext
#define   XmNxrtTblSensitiveContext                   "xrtTblSensitiveContext"
#endif /* XmNxrtTblSensitiveContext */

#ifndef   XmNxrtTblSensitiveSeries
#define   XmNxrtTblSensitiveSeries                    "xrtTblSensitiveSeries"
#endif /* XmNxrtTblSensitiveSeries */

#ifndef   XmNxrtTblStringPickListContext
#define   XmNxrtTblStringPickListContext              "xrtTblStringPickListContext"
#endif /* XmNxrtTblStringPickListContext */

#ifndef   XmNxrtTblStringPickListSeries
#define   XmNxrtTblStringPickListSeries               "xrtTblStringPickListSeries"
#endif /* XmNxrtTblStringPickListSeries */

#ifndef   XRTTBL_TYPE_FIELD_COMBO_CURRENCY
#define   XRTTBL_TYPE_FIELD_COMBO_CURRENCY            6
#define   XRTTBL_TYPE_FIELD_COMBO_DATE                7
#define   XRTTBL_TYPE_FIELD_COMBO_FLOAT               8
#define   XRTTBL_TYPE_FIELD_COMBO_INT                 9
#define   XRTTBL_TYPE_FIELD_COMBO_STRING              10
#define   XRTTBL_TYPE_FIELD_SPIN_CURRENCY             11
#define   XRTTBL_TYPE_FIELD_SPIN_DATE                 12
#define   XRTTBL_TYPE_FIELD_SPIN_FLOAT                13
#define   XRTTBL_TYPE_FIELD_SPIN_INT                  14
#define   XRTTBL_TYPE_FIELD_SPIN_STRING               15
#endif /* XRTTBL_TYPE_FIELD_SPIN_STRING */

#ifndef   XRTTBL_PREVIEW_NONE
#define   XRTTBL_PREVIEW_NONE                         0
#define   XRTTBL_PREVIEW_HORIZONTAL                   1
#define   XRTTBL_PREVIEW_VERTICAL                     2
#define   XRTTBL_PREVIEW_BOTH                         (XRTTBL_PREVIEW_HORIZONTAL | XRTTBL_PREVIEW_VERTICAL)
#endif /* XRTTBL_PREVIEW_VERTICAL */

#ifndef   XmRxrtTblPreviewScrolling
#define   XmRxrtTblPreviewScrolling                   "xrtTblPreviewScrolling"
#endif /* XmRxrtTblPreviewScrolling */

#ifndef   XmRxrtTblCurrencyPickList
#define   XmRxrtTblCurrencyPickList                   "xrtTblCurrencyPickList"
#endif /* XmRxrtTblCurrencyPickList */

#ifndef   XmRxrtTblCurrencyPickListSeries
#define   XmRxrtTblCurrencyPickListSeries             "xrtTblCurrencyPickListSeries"
#endif /* XmRxrtTblCurrencyPickListSeries */

#ifndef   XmRxrtTblDatePickList
#define   XmRxrtTblDatePickList                       "xrtTblDatePickList"
#endif /* XmRxrtTblDatePickList */

#ifndef   XmRxrtTblDatePickListSeries
#define   XmRxrtTblDatePickListSeries                 "xrtTblDatePickListSeries"
#endif /* XmRxrtTblDatePickListSeries */

#ifndef   XmRxrtTblFloatPickList
#define   XmRxrtTblFloatPickList                      "xrtTblFloatPickList"
#endif /* XmRxrtTblFloatPickList */

#ifndef   XmRxrtTblFloatPickListSeries
#define   XmRxrtTblFloatPickListSeries                "xrtTblFloatPickListSeries"
#endif /* XmRxrtTblFloatPickListSeries */

#ifndef   XmRxrtTblIntPickList
#define   XmRxrtTblIntPickList                        "xrtTblIntPickList"
#endif /* XmRxrtTblIntPickList */

#ifndef   XmRxrtTblIntPickListSeries
#define   XmRxrtTblIntPickListSeries                  "xrtTblIntPickListSeries"
#endif /* XmRxrtTblIntPickListSeries */

#ifndef   XmRxrtTblStringPickList
#define   XmRxrtTblStringPickList                     "xrtTblStringPickList"
#endif /* XmRxrtTblStringPickList */

#ifndef   XmRxrtTblStringPickListSeries
#define   XmRxrtTblStringPickListSeries               "xrtTblStringPickListSeries"
#endif /* XmRxrtTblStringPickListSeries */

#endif /* XRTTABLE_RELEASE < 3000 */

/*
** UNDEFINED RESOURCES:
**
** The following do appear in the widget resource table, so need some definitions
** to enable XDconfig to hide them:                                             
**
** Mapped out from the configuration since cannot generate compilable code
** unless the user explicitly defines these resources by hand
*/

/*
** Table Constraints
*/

#ifndef   XmNxrtTblCloned
#define   XmNxrtTblCloned           "xrtTblCloned"
#endif /* XmNxrtTblCloned */

#ifndef   XmNxrtTblTranslationsSet
#define   XmNxrtTblTranslationsSet  "xrtTblTranslationsSet"
#endif /* XmNxrtTblTranslationsSet */


/*
** XRT PDS 2 (Volume 13) Gear PanedWindow
*/

#ifndef   XmNxrtGearOldPosition
#define   XmNxrtGearOldPosition      "xrtGearOldPosition"
#endif /* XmNxrtGearOldPosition */

#ifndef   XmNxrtGearIsPane     
#define   XmNxrtGearIsPane           "xrtGearIsPane"
#endif /* XmNxrtGearIsPane */

#ifndef   XmNxrtGearDX     
#define   XmNxrtGearDX               "xrtGearDX"
#endif /* XmNxrtGearDX */

#ifndef   XmNxrtGearDY     
#define   XmNxrtGearDY               "xrtGearDY"
#endif /* XmNxrtGearDY */

#ifndef   XmNxrtGearDWidth     
#define   XmNxrtGearDWidth           "xrtGearDWidth"
#endif /* XmNxrtGearDWidth */

#ifndef   XmNxrtGearDHeight     
#define   XmNxrtGearDHeight          "xrtGearDHeight"
#endif /* XmNxrtGearDHeight */

/*
** Gear Tab Manager
*/

#ifndef   XmNxrtGearTabOffset
#define   XmNxrtGearTabOffset       "xrtGearTabOffset"
#endif /* XmNxrtGearTabOffset */

/*
** Gear Push Button
*/

#ifndef   XmNxrtGearUnarmPixmap
#define   XmNxrtGearUnarmPixmap     "xrtGearUnarmPixmap"
#endif /* XmNxrtGearUnarmPixmap */

/*
** Gear Toggle Button
*/

#ifndef   XmNxrtGearIsInitial
#define   XmNxrtGearIsInitial       "isInitial"
#endif /* XmNxrtGearIsInitial */

/*
** Field Float -> Double
**
** Unfortunately, XmRDouble is not defined anywhere
** although X-Designer knows how to handle it
*/

#ifndef   XmRDouble
#define   XmRDouble                 "Double"
#endif /* XmRDouble */

/*
** XRT PDS (Volume 14)
*/

#ifndef   XmNxrtGaUserInteractionData
#define   XmNxrtGaUserInteractionData   "xrtGaUserInteractionData"
#endif /* XmNxrtGaUserInteractionData */

/*
** XRT PDS 2.0.2 (Volume 15)
*/

/*
** 3D
*/

#ifndef   XtNxrt3dBorder
#define   XtNxrt3dBorder                              "xrt3dBorder"
#endif /* XtNxrt3dBorder */

/*
** Gauge
*/

#ifndef   XtNxrtGaColorMixPercentage
#define   XtNxrtGaColorMixPercentage                  "xrtGaColorMixPercentage"
#endif /* XtNxrtGaColorMixPercentage */

/*
** Patch to allow capture of Gear components containing the XRT/Clip widget, which is not public.
*/

extern WidgetClass xmXrtClipWidgetClass ;

#endif /* _XRT_XDESIGNER_MAP_H */
