#
# This makefile is provided as a template to create a customized version
# of X-Designer that is integrated with XRT/graph, XRT/3d, XRT/table, XRT/field, XRT/gear.
# This is only an example makefile and is provided as is.  The user is responsible
# for uncommenting and correcting this file to work within his or her own environment.
#
#  SCCSID -- @(#)Makefile.SCO  1.11 ; /* 01/06/07 */

XRTOBJS     = XRT_config.o XRT_code.o XRT_stubs.o
XRT_INC_DIR = $(XRTHOME)/include
XRT_LIB_DIR = $(XRTHOME)/lib

RM    = /bin/rm -f
CP    = /bin/cp
SHELL = /bin/sh

###########################################################################
# DO NOT EDIT the following lines.  Using "./Configure" with the appropriate
# options to configure this portion of the integration Makefile. Type
# "./Configure -help" for a list of valid options.
###########################################################################

HASFLAGS            = 
LIBXRTALL           = 
XD_PROG_NAME        = xdesigner
XD_PROG_BINARY      = xdesigner.bin
XD_OBJECT_DIRECTORY = obj
XD_ROOT_ENVIRON     = $(XDROOT)

###########################################################################

# sco
CC              = cc
CCC             = CC
CFLAGS          = -D_NO_PROTO $(HASFLAGS) -dy -b elf -Wl,-Bexport
CCFLAGS         =
LINKER          = $(CC)
LINKER_FLAGS    =

MOTIF_INC_DIR   = /usr/X/include
X11_INC_DIR     = /usr/X/include
MOTIF_LIB_DIR   = /usr/X/lib
X11_LIB_DIR     = /usr/X/lib
XLIBS           = -Bdynamic -lXext -lXm -lXmu -lXt -lX11 -lXp -lsocket -lnsl

CPPFLAGS        = -I$(XRT_INC_DIR) -I$(MOTIF_INC_DIR) -I$(X11_INC_DIR) -I../hdrs -I.
LDFLAGS         = -L$(XRT_LIB_DIR) -L$(MOTIF_LIB_DIR) -L$(X11_LIB_DIR)
STDLIBS         = -lm

XDOBJ           = $(XD_ROOT_ENVIRON)/user_widgets/$(XD_OBJECT_DIRECTORY)/$(XD_PROG_NAME).o
XDTMPOBJ        = /tmp/,tmp
LIBS            = $(LIBXRTALL) ${XLIBS} ${STDLIBS}

IFLAGS          = -I$(XRT_INC_DIR) -I$(XD_ROOT_ENVIRON)/user_widgets/hdrs -I${X11_INC_DIR} -I${MOTIF_INC_DIR} -I.

.c.o:
	$(RM) $@
	$(CC) -c $(CFLAGS) $(IFLAGS) $*.c

all: $(XD_PROG_BINARY)

$(XD_PROG_BINARY): $(XRTOBJS)
	$(LINKER) $(LINKER_FLAGS) -o $(XDTMPOBJ) $(XDOBJ) $(XRTOBJS) ${LDFLAGS} $(LIBS)
	mv $(XDTMPOBJ) $(XD_PROG_BINARY)
	$(XRTHOME)/bin/xrt_auth $(XD_PROG_BINARY)

clean:
	$(RM) $(XD_PROG_BINARY) $(XRTOBJS)

## Dependency to force stubs rebuild on generation
## otherwise if we augment the integrated set, stubs doesnt know

XRT_stubs.o: XRT_config.c XRT_code.c
